/*
 * Copyright 2020 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: google/cloud/audit/audit_log.proto

package org.apache.ratis.thirdparty.com.google.cloud.audit;

/**
 *
 *
 * <pre>
 * Metadata about the request.
 * </pre>
 *
 * Protobuf type {@code google.cloud.audit.RequestMetadata}
 */
public final class RequestMetadata extends org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3
    implements
    // @@protoc_insertion_point(message_implements:google.cloud.audit.RequestMetadata)
    RequestMetadataOrBuilder {
  private static final long serialVersionUID = 0L;
  // Use RequestMetadata.newBuilder() to construct.
  private RequestMetadata(org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }

  private RequestMetadata() {
    callerIp_ = "";
    callerSuppliedUserAgent_ = "";
    callerNetwork_ = "";
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(UnusedPrivateParameter unused) {
    return new RequestMetadata();
  }

  @java.lang.Override
  public final org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet getUnknownFields() {
    return this.unknownFields;
  }

  private RequestMetadata(
      org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
      org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    this();
    if (extensionRegistry == null) {
      throw new java.lang.NullPointerException();
    }
    org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet.Builder unknownFields =
        org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet.newBuilder();
    try {
      boolean done = false;
      while (!done) {
        int tag = input.readTag();
        switch (tag) {
          case 0:
            done = true;
            break;
          case 10:
            {
              java.lang.String s = input.readStringRequireUtf8();

              callerIp_ = s;
              break;
            }
          case 18:
            {
              java.lang.String s = input.readStringRequireUtf8();

              callerSuppliedUserAgent_ = s;
              break;
            }
          case 26:
            {
              java.lang.String s = input.readStringRequireUtf8();

              callerNetwork_ = s;
              break;
            }
          case 58:
            {
              org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Request.Builder subBuilder = null;
              if (requestAttributes_ != null) {
                subBuilder = requestAttributes_.toBuilder();
              }
              requestAttributes_ =
                  input.readMessage(
                      org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Request.parser(), extensionRegistry);
              if (subBuilder != null) {
                subBuilder.mergeFrom(requestAttributes_);
                requestAttributes_ = subBuilder.buildPartial();
              }

              break;
            }
          case 66:
            {
              org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Peer.Builder subBuilder = null;
              if (destinationAttributes_ != null) {
                subBuilder = destinationAttributes_.toBuilder();
              }
              destinationAttributes_ =
                  input.readMessage(
                      org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Peer.parser(), extensionRegistry);
              if (subBuilder != null) {
                subBuilder.mergeFrom(destinationAttributes_);
                destinationAttributes_ = subBuilder.buildPartial();
              }

              break;
            }
          default:
            {
              if (!parseUnknownField(input, unknownFields, extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
        }
      }
    } catch (org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException e) {
      throw e.setUnfinishedMessage(this);
    } catch (java.io.IOException e) {
      throw new org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException(e).setUnfinishedMessage(this);
    } finally {
      this.unknownFields = unknownFields.build();
      makeExtensionsImmutable();
    }
  }

  public static final org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
    return org.apache.ratis.thirdparty.com.google.cloud.audit.AuditLogProto
        .internal_static_google_cloud_audit_RequestMetadata_descriptor;
  }

  @java.lang.Override
  protected org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return org.apache.ratis.thirdparty.com.google.cloud.audit.AuditLogProto
        .internal_static_google_cloud_audit_RequestMetadata_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            org.apache.ratis.thirdparty.com.google.cloud.audit.RequestMetadata.class,
            org.apache.ratis.thirdparty.com.google.cloud.audit.RequestMetadata.Builder.class);
  }

  public static final int CALLER_IP_FIELD_NUMBER = 1;
  private volatile java.lang.Object callerIp_;
  /**
   *
   *
   * <pre>
   * The IP address of the caller.
   * For caller from internet, this will be public IPv4 or IPv6 address.
   * For caller from a Compute Engine VM with external IP address, this
   * will be the VM's external IP address. For caller from a Compute
   * Engine VM without external IP address, if the VM is in the same
   * organization (or project) as the accessed resource, `caller_ip` will
   * be the VM's internal IPv4 address, otherwise the `caller_ip` will be
   * redacted to "gce-internal-ip".
   * See https://cloud.google.com/compute/docs/vpc/ for more information.
   * </pre>
   *
   * <code>string caller_ip = 1;</code>
   *
   * @return The callerIp.
   */
  @java.lang.Override
  public java.lang.String getCallerIp() {
    java.lang.Object ref = callerIp_;
    if (ref instanceof java.lang.String) {
      return (java.lang.String) ref;
    } else {
      org.apache.ratis.thirdparty.com.google.protobuf.ByteString bs = (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
      java.lang.String s = bs.toStringUtf8();
      callerIp_ = s;
      return s;
    }
  }
  /**
   *
   *
   * <pre>
   * The IP address of the caller.
   * For caller from internet, this will be public IPv4 or IPv6 address.
   * For caller from a Compute Engine VM with external IP address, this
   * will be the VM's external IP address. For caller from a Compute
   * Engine VM without external IP address, if the VM is in the same
   * organization (or project) as the accessed resource, `caller_ip` will
   * be the VM's internal IPv4 address, otherwise the `caller_ip` will be
   * redacted to "gce-internal-ip".
   * See https://cloud.google.com/compute/docs/vpc/ for more information.
   * </pre>
   *
   * <code>string caller_ip = 1;</code>
   *
   * @return The bytes for callerIp.
   */
  @java.lang.Override
  public org.apache.ratis.thirdparty.com.google.protobuf.ByteString getCallerIpBytes() {
    java.lang.Object ref = callerIp_;
    if (ref instanceof java.lang.String) {
      org.apache.ratis.thirdparty.com.google.protobuf.ByteString b =
          org.apache.ratis.thirdparty.com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
      callerIp_ = b;
      return b;
    } else {
      return (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
    }
  }

  public static final int CALLER_SUPPLIED_USER_AGENT_FIELD_NUMBER = 2;
  private volatile java.lang.Object callerSuppliedUserAgent_;
  /**
   *
   *
   * <pre>
   * The user agent of the caller.
   * This information is not authenticated and should be treated accordingly.
   * For example:
   * +   `google-api-python-client/1.4.0`:
   *     The request was made by the Google API client for Python.
   * +   `Cloud SDK Command Line Tool apitools-client/1.0 gcloud/0.9.62`:
   *     The request was made by the Google Cloud SDK CLI (gcloud).
   * +   `AppEngine-Google; (+http://code.google.com/appengine; appid:
   * s~my-project`:
   *     The request was made from the `my-project` App Engine app.
   * </pre>
   *
   * <code>string caller_supplied_user_agent = 2;</code>
   *
   * @return The callerSuppliedUserAgent.
   */
  @java.lang.Override
  public java.lang.String getCallerSuppliedUserAgent() {
    java.lang.Object ref = callerSuppliedUserAgent_;
    if (ref instanceof java.lang.String) {
      return (java.lang.String) ref;
    } else {
      org.apache.ratis.thirdparty.com.google.protobuf.ByteString bs = (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
      java.lang.String s = bs.toStringUtf8();
      callerSuppliedUserAgent_ = s;
      return s;
    }
  }
  /**
   *
   *
   * <pre>
   * The user agent of the caller.
   * This information is not authenticated and should be treated accordingly.
   * For example:
   * +   `google-api-python-client/1.4.0`:
   *     The request was made by the Google API client for Python.
   * +   `Cloud SDK Command Line Tool apitools-client/1.0 gcloud/0.9.62`:
   *     The request was made by the Google Cloud SDK CLI (gcloud).
   * +   `AppEngine-Google; (+http://code.google.com/appengine; appid:
   * s~my-project`:
   *     The request was made from the `my-project` App Engine app.
   * </pre>
   *
   * <code>string caller_supplied_user_agent = 2;</code>
   *
   * @return The bytes for callerSuppliedUserAgent.
   */
  @java.lang.Override
  public org.apache.ratis.thirdparty.com.google.protobuf.ByteString getCallerSuppliedUserAgentBytes() {
    java.lang.Object ref = callerSuppliedUserAgent_;
    if (ref instanceof java.lang.String) {
      org.apache.ratis.thirdparty.com.google.protobuf.ByteString b =
          org.apache.ratis.thirdparty.com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
      callerSuppliedUserAgent_ = b;
      return b;
    } else {
      return (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
    }
  }

  public static final int CALLER_NETWORK_FIELD_NUMBER = 3;
  private volatile java.lang.Object callerNetwork_;
  /**
   *
   *
   * <pre>
   * The network of the caller.
   * Set only if the network host project is part of the same GCP organization
   * (or project) as the accessed resource.
   * See https://cloud.google.com/compute/docs/vpc/ for more information.
   * This is a scheme-less URI full resource name. For example:
   *     "//compute.googleapis.com/projects/PROJECT_ID/global/networks/NETWORK_ID"
   * </pre>
   *
   * <code>string caller_network = 3;</code>
   *
   * @return The callerNetwork.
   */
  @java.lang.Override
  public java.lang.String getCallerNetwork() {
    java.lang.Object ref = callerNetwork_;
    if (ref instanceof java.lang.String) {
      return (java.lang.String) ref;
    } else {
      org.apache.ratis.thirdparty.com.google.protobuf.ByteString bs = (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
      java.lang.String s = bs.toStringUtf8();
      callerNetwork_ = s;
      return s;
    }
  }
  /**
   *
   *
   * <pre>
   * The network of the caller.
   * Set only if the network host project is part of the same GCP organization
   * (or project) as the accessed resource.
   * See https://cloud.google.com/compute/docs/vpc/ for more information.
   * This is a scheme-less URI full resource name. For example:
   *     "//compute.googleapis.com/projects/PROJECT_ID/global/networks/NETWORK_ID"
   * </pre>
   *
   * <code>string caller_network = 3;</code>
   *
   * @return The bytes for callerNetwork.
   */
  @java.lang.Override
  public org.apache.ratis.thirdparty.com.google.protobuf.ByteString getCallerNetworkBytes() {
    java.lang.Object ref = callerNetwork_;
    if (ref instanceof java.lang.String) {
      org.apache.ratis.thirdparty.com.google.protobuf.ByteString b =
          org.apache.ratis.thirdparty.com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
      callerNetwork_ = b;
      return b;
    } else {
      return (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
    }
  }

  public static final int REQUEST_ATTRIBUTES_FIELD_NUMBER = 7;
  private org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Request requestAttributes_;
  /**
   *
   *
   * <pre>
   * Request attributes used in IAM condition evaluation. This field contains
   * request attributes like request time and access levels associated with
   * the request.
   * To get the whole view of the attributes used in IAM
   * condition evaluation, the user must also look into
   * `AuditLog.authentication_info.resource_attributes`.
   * </pre>
   *
   * <code>.google.rpc.context.AttributeContext.Request request_attributes = 7;</code>
   *
   * @return Whether the requestAttributes field is set.
   */
  @java.lang.Override
  public boolean hasRequestAttributes() {
    return requestAttributes_ != null;
  }
  /**
   *
   *
   * <pre>
   * Request attributes used in IAM condition evaluation. This field contains
   * request attributes like request time and access levels associated with
   * the request.
   * To get the whole view of the attributes used in IAM
   * condition evaluation, the user must also look into
   * `AuditLog.authentication_info.resource_attributes`.
   * </pre>
   *
   * <code>.google.rpc.context.AttributeContext.Request request_attributes = 7;</code>
   *
   * @return The requestAttributes.
   */
  @java.lang.Override
  public org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Request getRequestAttributes() {
    return requestAttributes_ == null
        ? org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Request.getDefaultInstance()
        : requestAttributes_;
  }
  /**
   *
   *
   * <pre>
   * Request attributes used in IAM condition evaluation. This field contains
   * request attributes like request time and access levels associated with
   * the request.
   * To get the whole view of the attributes used in IAM
   * condition evaluation, the user must also look into
   * `AuditLog.authentication_info.resource_attributes`.
   * </pre>
   *
   * <code>.google.rpc.context.AttributeContext.Request request_attributes = 7;</code>
   */
  @java.lang.Override
  public org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.RequestOrBuilder getRequestAttributesOrBuilder() {
    return getRequestAttributes();
  }

  public static final int DESTINATION_ATTRIBUTES_FIELD_NUMBER = 8;
  private org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Peer destinationAttributes_;
  /**
   *
   *
   * <pre>
   * The destination of a network activity, such as accepting a TCP connection.
   * In a multi hop network activity, the destination represents the receiver of
   * the last hop. Only two fields are used in this message, Peer.port and
   * Peer.ip. These fields are optionally populated by those services utilizing
   * the IAM condition feature.
   * </pre>
   *
   * <code>.google.rpc.context.AttributeContext.Peer destination_attributes = 8;</code>
   *
   * @return Whether the destinationAttributes field is set.
   */
  @java.lang.Override
  public boolean hasDestinationAttributes() {
    return destinationAttributes_ != null;
  }
  /**
   *
   *
   * <pre>
   * The destination of a network activity, such as accepting a TCP connection.
   * In a multi hop network activity, the destination represents the receiver of
   * the last hop. Only two fields are used in this message, Peer.port and
   * Peer.ip. These fields are optionally populated by those services utilizing
   * the IAM condition feature.
   * </pre>
   *
   * <code>.google.rpc.context.AttributeContext.Peer destination_attributes = 8;</code>
   *
   * @return The destinationAttributes.
   */
  @java.lang.Override
  public org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Peer getDestinationAttributes() {
    return destinationAttributes_ == null
        ? org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Peer.getDefaultInstance()
        : destinationAttributes_;
  }
  /**
   *
   *
   * <pre>
   * The destination of a network activity, such as accepting a TCP connection.
   * In a multi hop network activity, the destination represents the receiver of
   * the last hop. Only two fields are used in this message, Peer.port and
   * Peer.ip. These fields are optionally populated by those services utilizing
   * the IAM condition feature.
   * </pre>
   *
   * <code>.google.rpc.context.AttributeContext.Peer destination_attributes = 8;</code>
   */
  @java.lang.Override
  public org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.PeerOrBuilder getDestinationAttributesOrBuilder() {
    return getDestinationAttributes();
  }

  private byte memoizedIsInitialized = -1;

  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(org.apache.ratis.thirdparty.com.google.protobuf.CodedOutputStream output) throws java.io.IOException {
    if (!getCallerIpBytes().isEmpty()) {
      org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.writeString(output, 1, callerIp_);
    }
    if (!getCallerSuppliedUserAgentBytes().isEmpty()) {
      org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.writeString(output, 2, callerSuppliedUserAgent_);
    }
    if (!getCallerNetworkBytes().isEmpty()) {
      org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.writeString(output, 3, callerNetwork_);
    }
    if (requestAttributes_ != null) {
      output.writeMessage(7, getRequestAttributes());
    }
    if (destinationAttributes_ != null) {
      output.writeMessage(8, getDestinationAttributes());
    }
    unknownFields.writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (!getCallerIpBytes().isEmpty()) {
      size += org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.computeStringSize(1, callerIp_);
    }
    if (!getCallerSuppliedUserAgentBytes().isEmpty()) {
      size += org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.computeStringSize(2, callerSuppliedUserAgent_);
    }
    if (!getCallerNetworkBytes().isEmpty()) {
      size += org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.computeStringSize(3, callerNetwork_);
    }
    if (requestAttributes_ != null) {
      size += org.apache.ratis.thirdparty.com.google.protobuf.CodedOutputStream.computeMessageSize(7, getRequestAttributes());
    }
    if (destinationAttributes_ != null) {
      size +=
          org.apache.ratis.thirdparty.com.google.protobuf.CodedOutputStream.computeMessageSize(8, getDestinationAttributes());
    }
    size += unknownFields.getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
      return true;
    }
    if (!(obj instanceof org.apache.ratis.thirdparty.com.google.cloud.audit.RequestMetadata)) {
      return super.equals(obj);
    }
    org.apache.ratis.thirdparty.com.google.cloud.audit.RequestMetadata other = (org.apache.ratis.thirdparty.com.google.cloud.audit.RequestMetadata) obj;

    if (!getCallerIp().equals(other.getCallerIp())) return false;
    if (!getCallerSuppliedUserAgent().equals(other.getCallerSuppliedUserAgent())) return false;
    if (!getCallerNetwork().equals(other.getCallerNetwork())) return false;
    if (hasRequestAttributes() != other.hasRequestAttributes()) return false;
    if (hasRequestAttributes()) {
      if (!getRequestAttributes().equals(other.getRequestAttributes())) return false;
    }
    if (hasDestinationAttributes() != other.hasDestinationAttributes()) return false;
    if (hasDestinationAttributes()) {
      if (!getDestinationAttributes().equals(other.getDestinationAttributes())) return false;
    }
    if (!unknownFields.equals(other.unknownFields)) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    hash = (37 * hash) + CALLER_IP_FIELD_NUMBER;
    hash = (53 * hash) + getCallerIp().hashCode();
    hash = (37 * hash) + CALLER_SUPPLIED_USER_AGENT_FIELD_NUMBER;
    hash = (53 * hash) + getCallerSuppliedUserAgent().hashCode();
    hash = (37 * hash) + CALLER_NETWORK_FIELD_NUMBER;
    hash = (53 * hash) + getCallerNetwork().hashCode();
    if (hasRequestAttributes()) {
      hash = (37 * hash) + REQUEST_ATTRIBUTES_FIELD_NUMBER;
      hash = (53 * hash) + getRequestAttributes().hashCode();
    }
    if (hasDestinationAttributes()) {
      hash = (37 * hash) + DESTINATION_ATTRIBUTES_FIELD_NUMBER;
      hash = (53 * hash) + getDestinationAttributes().hashCode();
    }
    hash = (29 * hash) + unknownFields.hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.RequestMetadata parseFrom(java.nio.ByteBuffer data)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.RequestMetadata parseFrom(
      java.nio.ByteBuffer data, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.RequestMetadata parseFrom(
      org.apache.ratis.thirdparty.com.google.protobuf.ByteString data)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.RequestMetadata parseFrom(
      org.apache.ratis.thirdparty.com.google.protobuf.ByteString data,
      org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.RequestMetadata parseFrom(byte[] data)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.RequestMetadata parseFrom(
      byte[] data, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.RequestMetadata parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.RequestMetadata parseFrom(
      java.io.InputStream input, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(
        PARSER, input, extensionRegistry);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.RequestMetadata parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(PARSER, input);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.RequestMetadata parseDelimitedFrom(
      java.io.InputStream input, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(
        PARSER, input, extensionRegistry);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.RequestMetadata parseFrom(
      org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input) throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.RequestMetadata parseFrom(
      org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
      org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(
        PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() {
    return newBuilder();
  }

  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }

  public static Builder newBuilder(org.apache.ratis.thirdparty.com.google.cloud.audit.RequestMetadata prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }

  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   *
   *
   * <pre>
   * Metadata about the request.
   * </pre>
   *
   * Protobuf type {@code google.cloud.audit.RequestMetadata}
   */
  public static final class Builder extends org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.Builder<Builder>
      implements
      // @@protoc_insertion_point(builder_implements:google.cloud.audit.RequestMetadata)
      org.apache.ratis.thirdparty.com.google.cloud.audit.RequestMetadataOrBuilder {
    public static final org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
      return org.apache.ratis.thirdparty.com.google.cloud.audit.AuditLogProto
          .internal_static_google_cloud_audit_RequestMetadata_descriptor;
    }

    @java.lang.Override
    protected org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.apache.ratis.thirdparty.com.google.cloud.audit.AuditLogProto
          .internal_static_google_cloud_audit_RequestMetadata_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.apache.ratis.thirdparty.com.google.cloud.audit.RequestMetadata.class,
              org.apache.ratis.thirdparty.com.google.cloud.audit.RequestMetadata.Builder.class);
    }

    // Construct using org.apache.ratis.thirdparty.com.google.cloud.audit.RequestMetadata.newBuilder()
    private Builder() {
      maybeForceBuilderInitialization();
    }

    private Builder(org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);
      maybeForceBuilderInitialization();
    }

    private void maybeForceBuilderInitialization() {
      if (org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders) {}
    }

    @java.lang.Override
    public Builder clear() {
      super.clear();
      callerIp_ = "";

      callerSuppliedUserAgent_ = "";

      callerNetwork_ = "";

      if (requestAttributesBuilder_ == null) {
        requestAttributes_ = null;
      } else {
        requestAttributes_ = null;
        requestAttributesBuilder_ = null;
      }
      if (destinationAttributesBuilder_ == null) {
        destinationAttributes_ = null;
      } else {
        destinationAttributes_ = null;
        destinationAttributesBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.Descriptor getDescriptorForType() {
      return org.apache.ratis.thirdparty.com.google.cloud.audit.AuditLogProto
          .internal_static_google_cloud_audit_RequestMetadata_descriptor;
    }

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.cloud.audit.RequestMetadata getDefaultInstanceForType() {
      return org.apache.ratis.thirdparty.com.google.cloud.audit.RequestMetadata.getDefaultInstance();
    }

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.cloud.audit.RequestMetadata build() {
      org.apache.ratis.thirdparty.com.google.cloud.audit.RequestMetadata result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.cloud.audit.RequestMetadata buildPartial() {
      org.apache.ratis.thirdparty.com.google.cloud.audit.RequestMetadata result =
          new org.apache.ratis.thirdparty.com.google.cloud.audit.RequestMetadata(this);
      result.callerIp_ = callerIp_;
      result.callerSuppliedUserAgent_ = callerSuppliedUserAgent_;
      result.callerNetwork_ = callerNetwork_;
      if (requestAttributesBuilder_ == null) {
        result.requestAttributes_ = requestAttributes_;
      } else {
        result.requestAttributes_ = requestAttributesBuilder_.build();
      }
      if (destinationAttributesBuilder_ == null) {
        result.destinationAttributes_ = destinationAttributes_;
      } else {
        result.destinationAttributes_ = destinationAttributesBuilder_.build();
      }
      onBuilt();
      return result;
    }

    @java.lang.Override
    public Builder clone() {
      return super.clone();
    }

    @java.lang.Override
    public Builder setField(
        org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
      return super.setField(field, value);
    }

    @java.lang.Override
    public Builder clearField(org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field) {
      return super.clearField(field);
    }

    @java.lang.Override
    public Builder clearOneof(org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.OneofDescriptor oneof) {
      return super.clearOneof(oneof);
    }

    @java.lang.Override
    public Builder setRepeatedField(
        org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field, int index, java.lang.Object value) {
      return super.setRepeatedField(field, index, value);
    }

    @java.lang.Override
    public Builder addRepeatedField(
        org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
      return super.addRepeatedField(field, value);
    }

    @java.lang.Override
    public Builder mergeFrom(org.apache.ratis.thirdparty.com.google.protobuf.Message other) {
      if (other instanceof org.apache.ratis.thirdparty.com.google.cloud.audit.RequestMetadata) {
        return mergeFrom((org.apache.ratis.thirdparty.com.google.cloud.audit.RequestMetadata) other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(org.apache.ratis.thirdparty.com.google.cloud.audit.RequestMetadata other) {
      if (other == org.apache.ratis.thirdparty.com.google.cloud.audit.RequestMetadata.getDefaultInstance()) return this;
      if (!other.getCallerIp().isEmpty()) {
        callerIp_ = other.callerIp_;
        onChanged();
      }
      if (!other.getCallerSuppliedUserAgent().isEmpty()) {
        callerSuppliedUserAgent_ = other.callerSuppliedUserAgent_;
        onChanged();
      }
      if (!other.getCallerNetwork().isEmpty()) {
        callerNetwork_ = other.callerNetwork_;
        onChanged();
      }
      if (other.hasRequestAttributes()) {
        mergeRequestAttributes(other.getRequestAttributes());
      }
      if (other.hasDestinationAttributes()) {
        mergeDestinationAttributes(other.getDestinationAttributes());
      }
      this.mergeUnknownFields(other.unknownFields);
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
        org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      org.apache.ratis.thirdparty.com.google.cloud.audit.RequestMetadata parsedMessage = null;
      try {
        parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
      } catch (org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException e) {
        parsedMessage = (org.apache.ratis.thirdparty.com.google.cloud.audit.RequestMetadata) e.getUnfinishedMessage();
        throw e.unwrapIOException();
      } finally {
        if (parsedMessage != null) {
          mergeFrom(parsedMessage);
        }
      }
      return this;
    }

    private java.lang.Object callerIp_ = "";
    /**
     *
     *
     * <pre>
     * The IP address of the caller.
     * For caller from internet, this will be public IPv4 or IPv6 address.
     * For caller from a Compute Engine VM with external IP address, this
     * will be the VM's external IP address. For caller from a Compute
     * Engine VM without external IP address, if the VM is in the same
     * organization (or project) as the accessed resource, `caller_ip` will
     * be the VM's internal IPv4 address, otherwise the `caller_ip` will be
     * redacted to "gce-internal-ip".
     * See https://cloud.google.com/compute/docs/vpc/ for more information.
     * </pre>
     *
     * <code>string caller_ip = 1;</code>
     *
     * @return The callerIp.
     */
    public java.lang.String getCallerIp() {
      java.lang.Object ref = callerIp_;
      if (!(ref instanceof java.lang.String)) {
        org.apache.ratis.thirdparty.com.google.protobuf.ByteString bs = (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        callerIp_ = s;
        return s;
      } else {
        return (java.lang.String) ref;
      }
    }
    /**
     *
     *
     * <pre>
     * The IP address of the caller.
     * For caller from internet, this will be public IPv4 or IPv6 address.
     * For caller from a Compute Engine VM with external IP address, this
     * will be the VM's external IP address. For caller from a Compute
     * Engine VM without external IP address, if the VM is in the same
     * organization (or project) as the accessed resource, `caller_ip` will
     * be the VM's internal IPv4 address, otherwise the `caller_ip` will be
     * redacted to "gce-internal-ip".
     * See https://cloud.google.com/compute/docs/vpc/ for more information.
     * </pre>
     *
     * <code>string caller_ip = 1;</code>
     *
     * @return The bytes for callerIp.
     */
    public org.apache.ratis.thirdparty.com.google.protobuf.ByteString getCallerIpBytes() {
      java.lang.Object ref = callerIp_;
      if (ref instanceof String) {
        org.apache.ratis.thirdparty.com.google.protobuf.ByteString b =
            org.apache.ratis.thirdparty.com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
        callerIp_ = b;
        return b;
      } else {
        return (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
      }
    }
    /**
     *
     *
     * <pre>
     * The IP address of the caller.
     * For caller from internet, this will be public IPv4 or IPv6 address.
     * For caller from a Compute Engine VM with external IP address, this
     * will be the VM's external IP address. For caller from a Compute
     * Engine VM without external IP address, if the VM is in the same
     * organization (or project) as the accessed resource, `caller_ip` will
     * be the VM's internal IPv4 address, otherwise the `caller_ip` will be
     * redacted to "gce-internal-ip".
     * See https://cloud.google.com/compute/docs/vpc/ for more information.
     * </pre>
     *
     * <code>string caller_ip = 1;</code>
     *
     * @param value The callerIp to set.
     * @return This builder for chaining.
     */
    public Builder setCallerIp(java.lang.String value) {
      if (value == null) {
        throw new NullPointerException();
      }

      callerIp_ = value;
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * The IP address of the caller.
     * For caller from internet, this will be public IPv4 or IPv6 address.
     * For caller from a Compute Engine VM with external IP address, this
     * will be the VM's external IP address. For caller from a Compute
     * Engine VM without external IP address, if the VM is in the same
     * organization (or project) as the accessed resource, `caller_ip` will
     * be the VM's internal IPv4 address, otherwise the `caller_ip` will be
     * redacted to "gce-internal-ip".
     * See https://cloud.google.com/compute/docs/vpc/ for more information.
     * </pre>
     *
     * <code>string caller_ip = 1;</code>
     *
     * @return This builder for chaining.
     */
    public Builder clearCallerIp() {

      callerIp_ = getDefaultInstance().getCallerIp();
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * The IP address of the caller.
     * For caller from internet, this will be public IPv4 or IPv6 address.
     * For caller from a Compute Engine VM with external IP address, this
     * will be the VM's external IP address. For caller from a Compute
     * Engine VM without external IP address, if the VM is in the same
     * organization (or project) as the accessed resource, `caller_ip` will
     * be the VM's internal IPv4 address, otherwise the `caller_ip` will be
     * redacted to "gce-internal-ip".
     * See https://cloud.google.com/compute/docs/vpc/ for more information.
     * </pre>
     *
     * <code>string caller_ip = 1;</code>
     *
     * @param value The bytes for callerIp to set.
     * @return This builder for chaining.
     */
    public Builder setCallerIpBytes(org.apache.ratis.thirdparty.com.google.protobuf.ByteString value) {
      if (value == null) {
        throw new NullPointerException();
      }
      checkByteStringIsUtf8(value);

      callerIp_ = value;
      onChanged();
      return this;
    }

    private java.lang.Object callerSuppliedUserAgent_ = "";
    /**
     *
     *
     * <pre>
     * The user agent of the caller.
     * This information is not authenticated and should be treated accordingly.
     * For example:
     * +   `google-api-python-client/1.4.0`:
     *     The request was made by the Google API client for Python.
     * +   `Cloud SDK Command Line Tool apitools-client/1.0 gcloud/0.9.62`:
     *     The request was made by the Google Cloud SDK CLI (gcloud).
     * +   `AppEngine-Google; (+http://code.google.com/appengine; appid:
     * s~my-project`:
     *     The request was made from the `my-project` App Engine app.
     * </pre>
     *
     * <code>string caller_supplied_user_agent = 2;</code>
     *
     * @return The callerSuppliedUserAgent.
     */
    public java.lang.String getCallerSuppliedUserAgent() {
      java.lang.Object ref = callerSuppliedUserAgent_;
      if (!(ref instanceof java.lang.String)) {
        org.apache.ratis.thirdparty.com.google.protobuf.ByteString bs = (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        callerSuppliedUserAgent_ = s;
        return s;
      } else {
        return (java.lang.String) ref;
      }
    }
    /**
     *
     *
     * <pre>
     * The user agent of the caller.
     * This information is not authenticated and should be treated accordingly.
     * For example:
     * +   `google-api-python-client/1.4.0`:
     *     The request was made by the Google API client for Python.
     * +   `Cloud SDK Command Line Tool apitools-client/1.0 gcloud/0.9.62`:
     *     The request was made by the Google Cloud SDK CLI (gcloud).
     * +   `AppEngine-Google; (+http://code.google.com/appengine; appid:
     * s~my-project`:
     *     The request was made from the `my-project` App Engine app.
     * </pre>
     *
     * <code>string caller_supplied_user_agent = 2;</code>
     *
     * @return The bytes for callerSuppliedUserAgent.
     */
    public org.apache.ratis.thirdparty.com.google.protobuf.ByteString getCallerSuppliedUserAgentBytes() {
      java.lang.Object ref = callerSuppliedUserAgent_;
      if (ref instanceof String) {
        org.apache.ratis.thirdparty.com.google.protobuf.ByteString b =
            org.apache.ratis.thirdparty.com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
        callerSuppliedUserAgent_ = b;
        return b;
      } else {
        return (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
      }
    }
    /**
     *
     *
     * <pre>
     * The user agent of the caller.
     * This information is not authenticated and should be treated accordingly.
     * For example:
     * +   `google-api-python-client/1.4.0`:
     *     The request was made by the Google API client for Python.
     * +   `Cloud SDK Command Line Tool apitools-client/1.0 gcloud/0.9.62`:
     *     The request was made by the Google Cloud SDK CLI (gcloud).
     * +   `AppEngine-Google; (+http://code.google.com/appengine; appid:
     * s~my-project`:
     *     The request was made from the `my-project` App Engine app.
     * </pre>
     *
     * <code>string caller_supplied_user_agent = 2;</code>
     *
     * @param value The callerSuppliedUserAgent to set.
     * @return This builder for chaining.
     */
    public Builder setCallerSuppliedUserAgent(java.lang.String value) {
      if (value == null) {
        throw new NullPointerException();
      }

      callerSuppliedUserAgent_ = value;
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * The user agent of the caller.
     * This information is not authenticated and should be treated accordingly.
     * For example:
     * +   `google-api-python-client/1.4.0`:
     *     The request was made by the Google API client for Python.
     * +   `Cloud SDK Command Line Tool apitools-client/1.0 gcloud/0.9.62`:
     *     The request was made by the Google Cloud SDK CLI (gcloud).
     * +   `AppEngine-Google; (+http://code.google.com/appengine; appid:
     * s~my-project`:
     *     The request was made from the `my-project` App Engine app.
     * </pre>
     *
     * <code>string caller_supplied_user_agent = 2;</code>
     *
     * @return This builder for chaining.
     */
    public Builder clearCallerSuppliedUserAgent() {

      callerSuppliedUserAgent_ = getDefaultInstance().getCallerSuppliedUserAgent();
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * The user agent of the caller.
     * This information is not authenticated and should be treated accordingly.
     * For example:
     * +   `google-api-python-client/1.4.0`:
     *     The request was made by the Google API client for Python.
     * +   `Cloud SDK Command Line Tool apitools-client/1.0 gcloud/0.9.62`:
     *     The request was made by the Google Cloud SDK CLI (gcloud).
     * +   `AppEngine-Google; (+http://code.google.com/appengine; appid:
     * s~my-project`:
     *     The request was made from the `my-project` App Engine app.
     * </pre>
     *
     * <code>string caller_supplied_user_agent = 2;</code>
     *
     * @param value The bytes for callerSuppliedUserAgent to set.
     * @return This builder for chaining.
     */
    public Builder setCallerSuppliedUserAgentBytes(org.apache.ratis.thirdparty.com.google.protobuf.ByteString value) {
      if (value == null) {
        throw new NullPointerException();
      }
      checkByteStringIsUtf8(value);

      callerSuppliedUserAgent_ = value;
      onChanged();
      return this;
    }

    private java.lang.Object callerNetwork_ = "";
    /**
     *
     *
     * <pre>
     * The network of the caller.
     * Set only if the network host project is part of the same GCP organization
     * (or project) as the accessed resource.
     * See https://cloud.google.com/compute/docs/vpc/ for more information.
     * This is a scheme-less URI full resource name. For example:
     *     "//compute.googleapis.com/projects/PROJECT_ID/global/networks/NETWORK_ID"
     * </pre>
     *
     * <code>string caller_network = 3;</code>
     *
     * @return The callerNetwork.
     */
    public java.lang.String getCallerNetwork() {
      java.lang.Object ref = callerNetwork_;
      if (!(ref instanceof java.lang.String)) {
        org.apache.ratis.thirdparty.com.google.protobuf.ByteString bs = (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        callerNetwork_ = s;
        return s;
      } else {
        return (java.lang.String) ref;
      }
    }
    /**
     *
     *
     * <pre>
     * The network of the caller.
     * Set only if the network host project is part of the same GCP organization
     * (or project) as the accessed resource.
     * See https://cloud.google.com/compute/docs/vpc/ for more information.
     * This is a scheme-less URI full resource name. For example:
     *     "//compute.googleapis.com/projects/PROJECT_ID/global/networks/NETWORK_ID"
     * </pre>
     *
     * <code>string caller_network = 3;</code>
     *
     * @return The bytes for callerNetwork.
     */
    public org.apache.ratis.thirdparty.com.google.protobuf.ByteString getCallerNetworkBytes() {
      java.lang.Object ref = callerNetwork_;
      if (ref instanceof String) {
        org.apache.ratis.thirdparty.com.google.protobuf.ByteString b =
            org.apache.ratis.thirdparty.com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
        callerNetwork_ = b;
        return b;
      } else {
        return (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
      }
    }
    /**
     *
     *
     * <pre>
     * The network of the caller.
     * Set only if the network host project is part of the same GCP organization
     * (or project) as the accessed resource.
     * See https://cloud.google.com/compute/docs/vpc/ for more information.
     * This is a scheme-less URI full resource name. For example:
     *     "//compute.googleapis.com/projects/PROJECT_ID/global/networks/NETWORK_ID"
     * </pre>
     *
     * <code>string caller_network = 3;</code>
     *
     * @param value The callerNetwork to set.
     * @return This builder for chaining.
     */
    public Builder setCallerNetwork(java.lang.String value) {
      if (value == null) {
        throw new NullPointerException();
      }

      callerNetwork_ = value;
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * The network of the caller.
     * Set only if the network host project is part of the same GCP organization
     * (or project) as the accessed resource.
     * See https://cloud.google.com/compute/docs/vpc/ for more information.
     * This is a scheme-less URI full resource name. For example:
     *     "//compute.googleapis.com/projects/PROJECT_ID/global/networks/NETWORK_ID"
     * </pre>
     *
     * <code>string caller_network = 3;</code>
     *
     * @return This builder for chaining.
     */
    public Builder clearCallerNetwork() {

      callerNetwork_ = getDefaultInstance().getCallerNetwork();
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * The network of the caller.
     * Set only if the network host project is part of the same GCP organization
     * (or project) as the accessed resource.
     * See https://cloud.google.com/compute/docs/vpc/ for more information.
     * This is a scheme-less URI full resource name. For example:
     *     "//compute.googleapis.com/projects/PROJECT_ID/global/networks/NETWORK_ID"
     * </pre>
     *
     * <code>string caller_network = 3;</code>
     *
     * @param value The bytes for callerNetwork to set.
     * @return This builder for chaining.
     */
    public Builder setCallerNetworkBytes(org.apache.ratis.thirdparty.com.google.protobuf.ByteString value) {
      if (value == null) {
        throw new NullPointerException();
      }
      checkByteStringIsUtf8(value);

      callerNetwork_ = value;
      onChanged();
      return this;
    }

    private org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Request requestAttributes_;
    private org.apache.ratis.thirdparty.com.google.protobuf.SingleFieldBuilderV3<
            org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Request,
            org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Request.Builder,
            org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.RequestOrBuilder>
        requestAttributesBuilder_;
    /**
     *
     *
     * <pre>
     * Request attributes used in IAM condition evaluation. This field contains
     * request attributes like request time and access levels associated with
     * the request.
     * To get the whole view of the attributes used in IAM
     * condition evaluation, the user must also look into
     * `AuditLog.authentication_info.resource_attributes`.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Request request_attributes = 7;</code>
     *
     * @return Whether the requestAttributes field is set.
     */
    public boolean hasRequestAttributes() {
      return requestAttributesBuilder_ != null || requestAttributes_ != null;
    }
    /**
     *
     *
     * <pre>
     * Request attributes used in IAM condition evaluation. This field contains
     * request attributes like request time and access levels associated with
     * the request.
     * To get the whole view of the attributes used in IAM
     * condition evaluation, the user must also look into
     * `AuditLog.authentication_info.resource_attributes`.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Request request_attributes = 7;</code>
     *
     * @return The requestAttributes.
     */
    public org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Request getRequestAttributes() {
      if (requestAttributesBuilder_ == null) {
        return requestAttributes_ == null
            ? org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Request.getDefaultInstance()
            : requestAttributes_;
      } else {
        return requestAttributesBuilder_.getMessage();
      }
    }
    /**
     *
     *
     * <pre>
     * Request attributes used in IAM condition evaluation. This field contains
     * request attributes like request time and access levels associated with
     * the request.
     * To get the whole view of the attributes used in IAM
     * condition evaluation, the user must also look into
     * `AuditLog.authentication_info.resource_attributes`.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Request request_attributes = 7;</code>
     */
    public Builder setRequestAttributes(org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Request value) {
      if (requestAttributesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        requestAttributes_ = value;
        onChanged();
      } else {
        requestAttributesBuilder_.setMessage(value);
      }

      return this;
    }
    /**
     *
     *
     * <pre>
     * Request attributes used in IAM condition evaluation. This field contains
     * request attributes like request time and access levels associated with
     * the request.
     * To get the whole view of the attributes used in IAM
     * condition evaluation, the user must also look into
     * `AuditLog.authentication_info.resource_attributes`.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Request request_attributes = 7;</code>
     */
    public Builder setRequestAttributes(
        org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Request.Builder builderForValue) {
      if (requestAttributesBuilder_ == null) {
        requestAttributes_ = builderForValue.build();
        onChanged();
      } else {
        requestAttributesBuilder_.setMessage(builderForValue.build());
      }

      return this;
    }
    /**
     *
     *
     * <pre>
     * Request attributes used in IAM condition evaluation. This field contains
     * request attributes like request time and access levels associated with
     * the request.
     * To get the whole view of the attributes used in IAM
     * condition evaluation, the user must also look into
     * `AuditLog.authentication_info.resource_attributes`.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Request request_attributes = 7;</code>
     */
    public Builder mergeRequestAttributes(org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Request value) {
      if (requestAttributesBuilder_ == null) {
        if (requestAttributes_ != null) {
          requestAttributes_ =
              org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Request.newBuilder(requestAttributes_)
                  .mergeFrom(value)
                  .buildPartial();
        } else {
          requestAttributes_ = value;
        }
        onChanged();
      } else {
        requestAttributesBuilder_.mergeFrom(value);
      }

      return this;
    }
    /**
     *
     *
     * <pre>
     * Request attributes used in IAM condition evaluation. This field contains
     * request attributes like request time and access levels associated with
     * the request.
     * To get the whole view of the attributes used in IAM
     * condition evaluation, the user must also look into
     * `AuditLog.authentication_info.resource_attributes`.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Request request_attributes = 7;</code>
     */
    public Builder clearRequestAttributes() {
      if (requestAttributesBuilder_ == null) {
        requestAttributes_ = null;
        onChanged();
      } else {
        requestAttributes_ = null;
        requestAttributesBuilder_ = null;
      }

      return this;
    }
    /**
     *
     *
     * <pre>
     * Request attributes used in IAM condition evaluation. This field contains
     * request attributes like request time and access levels associated with
     * the request.
     * To get the whole view of the attributes used in IAM
     * condition evaluation, the user must also look into
     * `AuditLog.authentication_info.resource_attributes`.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Request request_attributes = 7;</code>
     */
    public org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Request.Builder getRequestAttributesBuilder() {

      onChanged();
      return getRequestAttributesFieldBuilder().getBuilder();
    }
    /**
     *
     *
     * <pre>
     * Request attributes used in IAM condition evaluation. This field contains
     * request attributes like request time and access levels associated with
     * the request.
     * To get the whole view of the attributes used in IAM
     * condition evaluation, the user must also look into
     * `AuditLog.authentication_info.resource_attributes`.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Request request_attributes = 7;</code>
     */
    public org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.RequestOrBuilder
        getRequestAttributesOrBuilder() {
      if (requestAttributesBuilder_ != null) {
        return requestAttributesBuilder_.getMessageOrBuilder();
      } else {
        return requestAttributes_ == null
            ? org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Request.getDefaultInstance()
            : requestAttributes_;
      }
    }
    /**
     *
     *
     * <pre>
     * Request attributes used in IAM condition evaluation. This field contains
     * request attributes like request time and access levels associated with
     * the request.
     * To get the whole view of the attributes used in IAM
     * condition evaluation, the user must also look into
     * `AuditLog.authentication_info.resource_attributes`.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Request request_attributes = 7;</code>
     */
    private org.apache.ratis.thirdparty.com.google.protobuf.SingleFieldBuilderV3<
            org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Request,
            org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Request.Builder,
            org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.RequestOrBuilder>
        getRequestAttributesFieldBuilder() {
      if (requestAttributesBuilder_ == null) {
        requestAttributesBuilder_ =
            new org.apache.ratis.thirdparty.com.google.protobuf.SingleFieldBuilderV3<
                org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Request,
                org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Request.Builder,
                org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.RequestOrBuilder>(
                getRequestAttributes(), getParentForChildren(), isClean());
        requestAttributes_ = null;
      }
      return requestAttributesBuilder_;
    }

    private org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Peer destinationAttributes_;
    private org.apache.ratis.thirdparty.com.google.protobuf.SingleFieldBuilderV3<
            org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Peer,
            org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Peer.Builder,
            org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.PeerOrBuilder>
        destinationAttributesBuilder_;
    /**
     *
     *
     * <pre>
     * The destination of a network activity, such as accepting a TCP connection.
     * In a multi hop network activity, the destination represents the receiver of
     * the last hop. Only two fields are used in this message, Peer.port and
     * Peer.ip. These fields are optionally populated by those services utilizing
     * the IAM condition feature.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Peer destination_attributes = 8;</code>
     *
     * @return Whether the destinationAttributes field is set.
     */
    public boolean hasDestinationAttributes() {
      return destinationAttributesBuilder_ != null || destinationAttributes_ != null;
    }
    /**
     *
     *
     * <pre>
     * The destination of a network activity, such as accepting a TCP connection.
     * In a multi hop network activity, the destination represents the receiver of
     * the last hop. Only two fields are used in this message, Peer.port and
     * Peer.ip. These fields are optionally populated by those services utilizing
     * the IAM condition feature.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Peer destination_attributes = 8;</code>
     *
     * @return The destinationAttributes.
     */
    public org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Peer getDestinationAttributes() {
      if (destinationAttributesBuilder_ == null) {
        return destinationAttributes_ == null
            ? org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Peer.getDefaultInstance()
            : destinationAttributes_;
      } else {
        return destinationAttributesBuilder_.getMessage();
      }
    }
    /**
     *
     *
     * <pre>
     * The destination of a network activity, such as accepting a TCP connection.
     * In a multi hop network activity, the destination represents the receiver of
     * the last hop. Only two fields are used in this message, Peer.port and
     * Peer.ip. These fields are optionally populated by those services utilizing
     * the IAM condition feature.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Peer destination_attributes = 8;</code>
     */
    public Builder setDestinationAttributes(org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Peer value) {
      if (destinationAttributesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        destinationAttributes_ = value;
        onChanged();
      } else {
        destinationAttributesBuilder_.setMessage(value);
      }

      return this;
    }
    /**
     *
     *
     * <pre>
     * The destination of a network activity, such as accepting a TCP connection.
     * In a multi hop network activity, the destination represents the receiver of
     * the last hop. Only two fields are used in this message, Peer.port and
     * Peer.ip. These fields are optionally populated by those services utilizing
     * the IAM condition feature.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Peer destination_attributes = 8;</code>
     */
    public Builder setDestinationAttributes(
        org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Peer.Builder builderForValue) {
      if (destinationAttributesBuilder_ == null) {
        destinationAttributes_ = builderForValue.build();
        onChanged();
      } else {
        destinationAttributesBuilder_.setMessage(builderForValue.build());
      }

      return this;
    }
    /**
     *
     *
     * <pre>
     * The destination of a network activity, such as accepting a TCP connection.
     * In a multi hop network activity, the destination represents the receiver of
     * the last hop. Only two fields are used in this message, Peer.port and
     * Peer.ip. These fields are optionally populated by those services utilizing
     * the IAM condition feature.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Peer destination_attributes = 8;</code>
     */
    public Builder mergeDestinationAttributes(org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Peer value) {
      if (destinationAttributesBuilder_ == null) {
        if (destinationAttributes_ != null) {
          destinationAttributes_ =
              org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Peer.newBuilder(destinationAttributes_)
                  .mergeFrom(value)
                  .buildPartial();
        } else {
          destinationAttributes_ = value;
        }
        onChanged();
      } else {
        destinationAttributesBuilder_.mergeFrom(value);
      }

      return this;
    }
    /**
     *
     *
     * <pre>
     * The destination of a network activity, such as accepting a TCP connection.
     * In a multi hop network activity, the destination represents the receiver of
     * the last hop. Only two fields are used in this message, Peer.port and
     * Peer.ip. These fields are optionally populated by those services utilizing
     * the IAM condition feature.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Peer destination_attributes = 8;</code>
     */
    public Builder clearDestinationAttributes() {
      if (destinationAttributesBuilder_ == null) {
        destinationAttributes_ = null;
        onChanged();
      } else {
        destinationAttributes_ = null;
        destinationAttributesBuilder_ = null;
      }

      return this;
    }
    /**
     *
     *
     * <pre>
     * The destination of a network activity, such as accepting a TCP connection.
     * In a multi hop network activity, the destination represents the receiver of
     * the last hop. Only two fields are used in this message, Peer.port and
     * Peer.ip. These fields are optionally populated by those services utilizing
     * the IAM condition feature.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Peer destination_attributes = 8;</code>
     */
    public org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Peer.Builder getDestinationAttributesBuilder() {

      onChanged();
      return getDestinationAttributesFieldBuilder().getBuilder();
    }
    /**
     *
     *
     * <pre>
     * The destination of a network activity, such as accepting a TCP connection.
     * In a multi hop network activity, the destination represents the receiver of
     * the last hop. Only two fields are used in this message, Peer.port and
     * Peer.ip. These fields are optionally populated by those services utilizing
     * the IAM condition feature.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Peer destination_attributes = 8;</code>
     */
    public org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.PeerOrBuilder
        getDestinationAttributesOrBuilder() {
      if (destinationAttributesBuilder_ != null) {
        return destinationAttributesBuilder_.getMessageOrBuilder();
      } else {
        return destinationAttributes_ == null
            ? org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Peer.getDefaultInstance()
            : destinationAttributes_;
      }
    }
    /**
     *
     *
     * <pre>
     * The destination of a network activity, such as accepting a TCP connection.
     * In a multi hop network activity, the destination represents the receiver of
     * the last hop. Only two fields are used in this message, Peer.port and
     * Peer.ip. These fields are optionally populated by those services utilizing
     * the IAM condition feature.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Peer destination_attributes = 8;</code>
     */
    private org.apache.ratis.thirdparty.com.google.protobuf.SingleFieldBuilderV3<
            org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Peer,
            org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Peer.Builder,
            org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.PeerOrBuilder>
        getDestinationAttributesFieldBuilder() {
      if (destinationAttributesBuilder_ == null) {
        destinationAttributesBuilder_ =
            new org.apache.ratis.thirdparty.com.google.protobuf.SingleFieldBuilderV3<
                org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Peer,
                org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Peer.Builder,
                org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.PeerOrBuilder>(
                getDestinationAttributes(), getParentForChildren(), isClean());
        destinationAttributes_ = null;
      }
      return destinationAttributesBuilder_;
    }

    @java.lang.Override
    public final Builder setUnknownFields(final org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }

    // @@protoc_insertion_point(builder_scope:google.cloud.audit.RequestMetadata)
  }

  // @@protoc_insertion_point(class_scope:google.cloud.audit.RequestMetadata)
  private static final org.apache.ratis.thirdparty.com.google.cloud.audit.RequestMetadata DEFAULT_INSTANCE;

  static {
    DEFAULT_INSTANCE = new org.apache.ratis.thirdparty.com.google.cloud.audit.RequestMetadata();
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.RequestMetadata getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final org.apache.ratis.thirdparty.com.google.protobuf.Parser<RequestMetadata> PARSER =
      new org.apache.ratis.thirdparty.com.google.protobuf.AbstractParser<RequestMetadata>() {
        @java.lang.Override
        public RequestMetadata parsePartialFrom(
            org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
            org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
          return new RequestMetadata(input, extensionRegistry);
        }
      };

  public static org.apache.ratis.thirdparty.com.google.protobuf.Parser<RequestMetadata> parser() {
    return PARSER;
  }

  @java.lang.Override
  public org.apache.ratis.thirdparty.com.google.protobuf.Parser<RequestMetadata> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public org.apache.ratis.thirdparty.com.google.cloud.audit.RequestMetadata getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }
}
