/*
 * Copyright 2020 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: google/rpc/error_details.proto

package org.apache.ratis.thirdparty.com.google.rpc;

/**
 *
 *
 * <pre>
 * Provides links to documentation or for performing an out of band action.
 * For example, if a quota check failed with an error indicating the calling
 * project hasn't enabled the accessed service, this can contain a URL pointing
 * directly to the right place in the developer console to flip the bit.
 * </pre>
 *
 * Protobuf type {@code google.rpc.Help}
 */
public final class Help extends org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3
    implements
    // @@protoc_insertion_point(message_implements:google.rpc.Help)
    HelpOrBuilder {
  private static final long serialVersionUID = 0L;
  // Use Help.newBuilder() to construct.
  private Help(org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }

  private Help() {
    links_ = java.util.Collections.emptyList();
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(UnusedPrivateParameter unused) {
    return new Help();
  }

  @java.lang.Override
  public final org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet getUnknownFields() {
    return this.unknownFields;
  }

  private Help(
      org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
      org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    this();
    if (extensionRegistry == null) {
      throw new java.lang.NullPointerException();
    }
    int mutable_bitField0_ = 0;
    org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet.Builder unknownFields =
        org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet.newBuilder();
    try {
      boolean done = false;
      while (!done) {
        int tag = input.readTag();
        switch (tag) {
          case 0:
            done = true;
            break;
          case 10:
            {
              if (!((mutable_bitField0_ & 0x00000001) != 0)) {
                links_ = new java.util.ArrayList<org.apache.ratis.thirdparty.com.google.rpc.Help.Link>();
                mutable_bitField0_ |= 0x00000001;
              }
              links_.add(input.readMessage(org.apache.ratis.thirdparty.com.google.rpc.Help.Link.parser(), extensionRegistry));
              break;
            }
          default:
            {
              if (!parseUnknownField(input, unknownFields, extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
        }
      }
    } catch (org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException e) {
      throw e.setUnfinishedMessage(this);
    } catch (java.io.IOException e) {
      throw new org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException(e).setUnfinishedMessage(this);
    } finally {
      if (((mutable_bitField0_ & 0x00000001) != 0)) {
        links_ = java.util.Collections.unmodifiableList(links_);
      }
      this.unknownFields = unknownFields.build();
      makeExtensionsImmutable();
    }
  }

  public static final org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
    return org.apache.ratis.thirdparty.com.google.rpc.ErrorDetailsProto.internal_static_google_rpc_Help_descriptor;
  }

  @java.lang.Override
  protected org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return org.apache.ratis.thirdparty.com.google.rpc.ErrorDetailsProto.internal_static_google_rpc_Help_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            org.apache.ratis.thirdparty.com.google.rpc.Help.class, org.apache.ratis.thirdparty.com.google.rpc.Help.Builder.class);
  }

  public interface LinkOrBuilder
      extends
      // @@protoc_insertion_point(interface_extends:google.rpc.Help.Link)
      org.apache.ratis.thirdparty.com.google.protobuf.MessageOrBuilder {

    /**
     *
     *
     * <pre>
     * Describes what the link offers.
     * </pre>
     *
     * <code>string description = 1;</code>
     *
     * @return The description.
     */
    java.lang.String getDescription();
    /**
     *
     *
     * <pre>
     * Describes what the link offers.
     * </pre>
     *
     * <code>string description = 1;</code>
     *
     * @return The bytes for description.
     */
    org.apache.ratis.thirdparty.com.google.protobuf.ByteString getDescriptionBytes();

    /**
     *
     *
     * <pre>
     * The URL of the link.
     * </pre>
     *
     * <code>string url = 2;</code>
     *
     * @return The url.
     */
    java.lang.String getUrl();
    /**
     *
     *
     * <pre>
     * The URL of the link.
     * </pre>
     *
     * <code>string url = 2;</code>
     *
     * @return The bytes for url.
     */
    org.apache.ratis.thirdparty.com.google.protobuf.ByteString getUrlBytes();
  }
  /**
   *
   *
   * <pre>
   * Describes a URL link.
   * </pre>
   *
   * Protobuf type {@code google.rpc.Help.Link}
   */
  public static final class Link extends org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3
      implements
      // @@protoc_insertion_point(message_implements:google.rpc.Help.Link)
      LinkOrBuilder {
    private static final long serialVersionUID = 0L;
    // Use Link.newBuilder() to construct.
    private Link(org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }

    private Link() {
      description_ = "";
      url_ = "";
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(UnusedPrivateParameter unused) {
      return new Link();
    }

    @java.lang.Override
    public final org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet getUnknownFields() {
      return this.unknownFields;
    }

    private Link(
        org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
        org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
      this();
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10:
              {
                java.lang.String s = input.readStringRequireUtf8();

                description_ = s;
                break;
              }
            case 18:
              {
                java.lang.String s = input.readStringRequireUtf8();

                url_ = s;
                break;
              }
            default:
              {
                if (!parseUnknownField(input, unknownFields, extensionRegistry, tag)) {
                  done = true;
                }
                break;
              }
          }
        }
      } catch (org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException(e).setUnfinishedMessage(this);
      } finally {
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }

    public static final org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
      return org.apache.ratis.thirdparty.com.google.rpc.ErrorDetailsProto.internal_static_google_rpc_Help_Link_descriptor;
    }

    @java.lang.Override
    protected org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.apache.ratis.thirdparty.com.google.rpc.ErrorDetailsProto
          .internal_static_google_rpc_Help_Link_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.apache.ratis.thirdparty.com.google.rpc.Help.Link.class, org.apache.ratis.thirdparty.com.google.rpc.Help.Link.Builder.class);
    }

    public static final int DESCRIPTION_FIELD_NUMBER = 1;
    private volatile java.lang.Object description_;
    /**
     *
     *
     * <pre>
     * Describes what the link offers.
     * </pre>
     *
     * <code>string description = 1;</code>
     *
     * @return The description.
     */
    @java.lang.Override
    public java.lang.String getDescription() {
      java.lang.Object ref = description_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        org.apache.ratis.thirdparty.com.google.protobuf.ByteString bs = (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        description_ = s;
        return s;
      }
    }
    /**
     *
     *
     * <pre>
     * Describes what the link offers.
     * </pre>
     *
     * <code>string description = 1;</code>
     *
     * @return The bytes for description.
     */
    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.protobuf.ByteString getDescriptionBytes() {
      java.lang.Object ref = description_;
      if (ref instanceof java.lang.String) {
        org.apache.ratis.thirdparty.com.google.protobuf.ByteString b =
            org.apache.ratis.thirdparty.com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
        description_ = b;
        return b;
      } else {
        return (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
      }
    }

    public static final int URL_FIELD_NUMBER = 2;
    private volatile java.lang.Object url_;
    /**
     *
     *
     * <pre>
     * The URL of the link.
     * </pre>
     *
     * <code>string url = 2;</code>
     *
     * @return The url.
     */
    @java.lang.Override
    public java.lang.String getUrl() {
      java.lang.Object ref = url_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        org.apache.ratis.thirdparty.com.google.protobuf.ByteString bs = (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        url_ = s;
        return s;
      }
    }
    /**
     *
     *
     * <pre>
     * The URL of the link.
     * </pre>
     *
     * <code>string url = 2;</code>
     *
     * @return The bytes for url.
     */
    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.protobuf.ByteString getUrlBytes() {
      java.lang.Object ref = url_;
      if (ref instanceof java.lang.String) {
        org.apache.ratis.thirdparty.com.google.protobuf.ByteString b =
            org.apache.ratis.thirdparty.com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
        url_ = b;
        return b;
      } else {
        return (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
      }
    }

    private byte memoizedIsInitialized = -1;

    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(org.apache.ratis.thirdparty.com.google.protobuf.CodedOutputStream output) throws java.io.IOException {
      if (!getDescriptionBytes().isEmpty()) {
        org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.writeString(output, 1, description_);
      }
      if (!getUrlBytes().isEmpty()) {
        org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.writeString(output, 2, url_);
      }
      unknownFields.writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (!getDescriptionBytes().isEmpty()) {
        size += org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.computeStringSize(1, description_);
      }
      if (!getUrlBytes().isEmpty()) {
        size += org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.computeStringSize(2, url_);
      }
      size += unknownFields.getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
        return true;
      }
      if (!(obj instanceof org.apache.ratis.thirdparty.com.google.rpc.Help.Link)) {
        return super.equals(obj);
      }
      org.apache.ratis.thirdparty.com.google.rpc.Help.Link other = (org.apache.ratis.thirdparty.com.google.rpc.Help.Link) obj;

      if (!getDescription().equals(other.getDescription())) return false;
      if (!getUrl().equals(other.getUrl())) return false;
      if (!unknownFields.equals(other.unknownFields)) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      hash = (37 * hash) + DESCRIPTION_FIELD_NUMBER;
      hash = (53 * hash) + getDescription().hashCode();
      hash = (37 * hash) + URL_FIELD_NUMBER;
      hash = (53 * hash) + getUrl().hashCode();
      hash = (29 * hash) + unknownFields.hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static org.apache.ratis.thirdparty.com.google.rpc.Help.Link parseFrom(java.nio.ByteBuffer data)
        throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }

    public static org.apache.ratis.thirdparty.com.google.rpc.Help.Link parseFrom(
        java.nio.ByteBuffer data, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }

    public static org.apache.ratis.thirdparty.com.google.rpc.Help.Link parseFrom(org.apache.ratis.thirdparty.com.google.protobuf.ByteString data)
        throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }

    public static org.apache.ratis.thirdparty.com.google.rpc.Help.Link parseFrom(
        org.apache.ratis.thirdparty.com.google.protobuf.ByteString data,
        org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }

    public static org.apache.ratis.thirdparty.com.google.rpc.Help.Link parseFrom(byte[] data)
        throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }

    public static org.apache.ratis.thirdparty.com.google.rpc.Help.Link parseFrom(
        byte[] data, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }

    public static org.apache.ratis.thirdparty.com.google.rpc.Help.Link parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
    }

    public static org.apache.ratis.thirdparty.com.google.rpc.Help.Link parseFrom(
        java.io.InputStream input, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(
          PARSER, input, extensionRegistry);
    }

    public static org.apache.ratis.thirdparty.com.google.rpc.Help.Link parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(PARSER, input);
    }

    public static org.apache.ratis.thirdparty.com.google.rpc.Help.Link parseDelimitedFrom(
        java.io.InputStream input, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(
          PARSER, input, extensionRegistry);
    }

    public static org.apache.ratis.thirdparty.com.google.rpc.Help.Link parseFrom(org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
    }

    public static org.apache.ratis.thirdparty.com.google.rpc.Help.Link parseFrom(
        org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
        org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(
          PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() {
      return newBuilder();
    }

    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }

    public static Builder newBuilder(org.apache.ratis.thirdparty.com.google.rpc.Help.Link prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }

    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     *
     *
     * <pre>
     * Describes a URL link.
     * </pre>
     *
     * Protobuf type {@code google.rpc.Help.Link}
     */
    public static final class Builder
        extends org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.Builder<Builder>
        implements
        // @@protoc_insertion_point(builder_implements:google.rpc.Help.Link)
        org.apache.ratis.thirdparty.com.google.rpc.Help.LinkOrBuilder {
      public static final org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
        return org.apache.ratis.thirdparty.com.google.rpc.ErrorDetailsProto.internal_static_google_rpc_Help_Link_descriptor;
      }

      @java.lang.Override
      protected org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.apache.ratis.thirdparty.com.google.rpc.ErrorDetailsProto
            .internal_static_google_rpc_Help_Link_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.apache.ratis.thirdparty.com.google.rpc.Help.Link.class, org.apache.ratis.thirdparty.com.google.rpc.Help.Link.Builder.class);
      }

      // Construct using org.apache.ratis.thirdparty.com.google.rpc.Help.Link.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }

      private void maybeForceBuilderInitialization() {
        if (org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders) {}
      }

      @java.lang.Override
      public Builder clear() {
        super.clear();
        description_ = "";

        url_ = "";

        return this;
      }

      @java.lang.Override
      public org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.Descriptor getDescriptorForType() {
        return org.apache.ratis.thirdparty.com.google.rpc.ErrorDetailsProto.internal_static_google_rpc_Help_Link_descriptor;
      }

      @java.lang.Override
      public org.apache.ratis.thirdparty.com.google.rpc.Help.Link getDefaultInstanceForType() {
        return org.apache.ratis.thirdparty.com.google.rpc.Help.Link.getDefaultInstance();
      }

      @java.lang.Override
      public org.apache.ratis.thirdparty.com.google.rpc.Help.Link build() {
        org.apache.ratis.thirdparty.com.google.rpc.Help.Link result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public org.apache.ratis.thirdparty.com.google.rpc.Help.Link buildPartial() {
        org.apache.ratis.thirdparty.com.google.rpc.Help.Link result = new org.apache.ratis.thirdparty.com.google.rpc.Help.Link(this);
        result.description_ = description_;
        result.url_ = url_;
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }

      @java.lang.Override
      public Builder setField(
          org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
        return super.setField(field, value);
      }

      @java.lang.Override
      public Builder clearField(org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }

      @java.lang.Override
      public Builder clearOneof(org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }

      @java.lang.Override
      public Builder setRepeatedField(
          org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field,
          int index,
          java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }

      @java.lang.Override
      public Builder addRepeatedField(
          org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }

      @java.lang.Override
      public Builder mergeFrom(org.apache.ratis.thirdparty.com.google.protobuf.Message other) {
        if (other instanceof org.apache.ratis.thirdparty.com.google.rpc.Help.Link) {
          return mergeFrom((org.apache.ratis.thirdparty.com.google.rpc.Help.Link) other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(org.apache.ratis.thirdparty.com.google.rpc.Help.Link other) {
        if (other == org.apache.ratis.thirdparty.com.google.rpc.Help.Link.getDefaultInstance()) return this;
        if (!other.getDescription().isEmpty()) {
          description_ = other.description_;
          onChanged();
        }
        if (!other.getUrl().isEmpty()) {
          url_ = other.url_;
          onChanged();
        }
        this.mergeUnknownFields(other.unknownFields);
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
          org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.apache.ratis.thirdparty.com.google.rpc.Help.Link parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException e) {
          parsedMessage = (org.apache.ratis.thirdparty.com.google.rpc.Help.Link) e.getUnfinishedMessage();
          throw e.unwrapIOException();
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }

      private java.lang.Object description_ = "";
      /**
       *
       *
       * <pre>
       * Describes what the link offers.
       * </pre>
       *
       * <code>string description = 1;</code>
       *
       * @return The description.
       */
      public java.lang.String getDescription() {
        java.lang.Object ref = description_;
        if (!(ref instanceof java.lang.String)) {
          org.apache.ratis.thirdparty.com.google.protobuf.ByteString bs = (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          description_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * Describes what the link offers.
       * </pre>
       *
       * <code>string description = 1;</code>
       *
       * @return The bytes for description.
       */
      public org.apache.ratis.thirdparty.com.google.protobuf.ByteString getDescriptionBytes() {
        java.lang.Object ref = description_;
        if (ref instanceof String) {
          org.apache.ratis.thirdparty.com.google.protobuf.ByteString b =
              org.apache.ratis.thirdparty.com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
          description_ = b;
          return b;
        } else {
          return (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * Describes what the link offers.
       * </pre>
       *
       * <code>string description = 1;</code>
       *
       * @param value The description to set.
       * @return This builder for chaining.
       */
      public Builder setDescription(java.lang.String value) {
        if (value == null) {
          throw new NullPointerException();
        }

        description_ = value;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * Describes what the link offers.
       * </pre>
       *
       * <code>string description = 1;</code>
       *
       * @return This builder for chaining.
       */
      public Builder clearDescription() {

        description_ = getDefaultInstance().getDescription();
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * Describes what the link offers.
       * </pre>
       *
       * <code>string description = 1;</code>
       *
       * @param value The bytes for description to set.
       * @return This builder for chaining.
       */
      public Builder setDescriptionBytes(org.apache.ratis.thirdparty.com.google.protobuf.ByteString value) {
        if (value == null) {
          throw new NullPointerException();
        }
        checkByteStringIsUtf8(value);

        description_ = value;
        onChanged();
        return this;
      }

      private java.lang.Object url_ = "";
      /**
       *
       *
       * <pre>
       * The URL of the link.
       * </pre>
       *
       * <code>string url = 2;</code>
       *
       * @return The url.
       */
      public java.lang.String getUrl() {
        java.lang.Object ref = url_;
        if (!(ref instanceof java.lang.String)) {
          org.apache.ratis.thirdparty.com.google.protobuf.ByteString bs = (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          url_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The URL of the link.
       * </pre>
       *
       * <code>string url = 2;</code>
       *
       * @return The bytes for url.
       */
      public org.apache.ratis.thirdparty.com.google.protobuf.ByteString getUrlBytes() {
        java.lang.Object ref = url_;
        if (ref instanceof String) {
          org.apache.ratis.thirdparty.com.google.protobuf.ByteString b =
              org.apache.ratis.thirdparty.com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
          url_ = b;
          return b;
        } else {
          return (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The URL of the link.
       * </pre>
       *
       * <code>string url = 2;</code>
       *
       * @param value The url to set.
       * @return This builder for chaining.
       */
      public Builder setUrl(java.lang.String value) {
        if (value == null) {
          throw new NullPointerException();
        }

        url_ = value;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The URL of the link.
       * </pre>
       *
       * <code>string url = 2;</code>
       *
       * @return This builder for chaining.
       */
      public Builder clearUrl() {

        url_ = getDefaultInstance().getUrl();
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The URL of the link.
       * </pre>
       *
       * <code>string url = 2;</code>
       *
       * @param value The bytes for url to set.
       * @return This builder for chaining.
       */
      public Builder setUrlBytes(org.apache.ratis.thirdparty.com.google.protobuf.ByteString value) {
        if (value == null) {
          throw new NullPointerException();
        }
        checkByteStringIsUtf8(value);

        url_ = value;
        onChanged();
        return this;
      }

      @java.lang.Override
      public final Builder setUnknownFields(
          final org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }

      // @@protoc_insertion_point(builder_scope:google.rpc.Help.Link)
    }

    // @@protoc_insertion_point(class_scope:google.rpc.Help.Link)
    private static final org.apache.ratis.thirdparty.com.google.rpc.Help.Link DEFAULT_INSTANCE;

    static {
      DEFAULT_INSTANCE = new org.apache.ratis.thirdparty.com.google.rpc.Help.Link();
    }

    public static org.apache.ratis.thirdparty.com.google.rpc.Help.Link getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final org.apache.ratis.thirdparty.com.google.protobuf.Parser<Link> PARSER =
        new org.apache.ratis.thirdparty.com.google.protobuf.AbstractParser<Link>() {
          @java.lang.Override
          public Link parsePartialFrom(
              org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
              org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
              throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
            return new Link(input, extensionRegistry);
          }
        };

    public static org.apache.ratis.thirdparty.com.google.protobuf.Parser<Link> parser() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.protobuf.Parser<Link> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.rpc.Help.Link getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }
  }

  public static final int LINKS_FIELD_NUMBER = 1;
  private java.util.List<org.apache.ratis.thirdparty.com.google.rpc.Help.Link> links_;
  /**
   *
   *
   * <pre>
   * URL(s) pointing to additional information on handling the current error.
   * </pre>
   *
   * <code>repeated .google.rpc.Help.Link links = 1;</code>
   */
  @java.lang.Override
  public java.util.List<org.apache.ratis.thirdparty.com.google.rpc.Help.Link> getLinksList() {
    return links_;
  }
  /**
   *
   *
   * <pre>
   * URL(s) pointing to additional information on handling the current error.
   * </pre>
   *
   * <code>repeated .google.rpc.Help.Link links = 1;</code>
   */
  @java.lang.Override
  public java.util.List<? extends org.apache.ratis.thirdparty.com.google.rpc.Help.LinkOrBuilder> getLinksOrBuilderList() {
    return links_;
  }
  /**
   *
   *
   * <pre>
   * URL(s) pointing to additional information on handling the current error.
   * </pre>
   *
   * <code>repeated .google.rpc.Help.Link links = 1;</code>
   */
  @java.lang.Override
  public int getLinksCount() {
    return links_.size();
  }
  /**
   *
   *
   * <pre>
   * URL(s) pointing to additional information on handling the current error.
   * </pre>
   *
   * <code>repeated .google.rpc.Help.Link links = 1;</code>
   */
  @java.lang.Override
  public org.apache.ratis.thirdparty.com.google.rpc.Help.Link getLinks(int index) {
    return links_.get(index);
  }
  /**
   *
   *
   * <pre>
   * URL(s) pointing to additional information on handling the current error.
   * </pre>
   *
   * <code>repeated .google.rpc.Help.Link links = 1;</code>
   */
  @java.lang.Override
  public org.apache.ratis.thirdparty.com.google.rpc.Help.LinkOrBuilder getLinksOrBuilder(int index) {
    return links_.get(index);
  }

  private byte memoizedIsInitialized = -1;

  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(org.apache.ratis.thirdparty.com.google.protobuf.CodedOutputStream output) throws java.io.IOException {
    for (int i = 0; i < links_.size(); i++) {
      output.writeMessage(1, links_.get(i));
    }
    unknownFields.writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    for (int i = 0; i < links_.size(); i++) {
      size += org.apache.ratis.thirdparty.com.google.protobuf.CodedOutputStream.computeMessageSize(1, links_.get(i));
    }
    size += unknownFields.getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
      return true;
    }
    if (!(obj instanceof org.apache.ratis.thirdparty.com.google.rpc.Help)) {
      return super.equals(obj);
    }
    org.apache.ratis.thirdparty.com.google.rpc.Help other = (org.apache.ratis.thirdparty.com.google.rpc.Help) obj;

    if (!getLinksList().equals(other.getLinksList())) return false;
    if (!unknownFields.equals(other.unknownFields)) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (getLinksCount() > 0) {
      hash = (37 * hash) + LINKS_FIELD_NUMBER;
      hash = (53 * hash) + getLinksList().hashCode();
    }
    hash = (29 * hash) + unknownFields.hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static org.apache.ratis.thirdparty.com.google.rpc.Help parseFrom(java.nio.ByteBuffer data)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }

  public static org.apache.ratis.thirdparty.com.google.rpc.Help parseFrom(
      java.nio.ByteBuffer data, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }

  public static org.apache.ratis.thirdparty.com.google.rpc.Help parseFrom(org.apache.ratis.thirdparty.com.google.protobuf.ByteString data)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }

  public static org.apache.ratis.thirdparty.com.google.rpc.Help parseFrom(
      org.apache.ratis.thirdparty.com.google.protobuf.ByteString data,
      org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }

  public static org.apache.ratis.thirdparty.com.google.rpc.Help parseFrom(byte[] data)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }

  public static org.apache.ratis.thirdparty.com.google.rpc.Help parseFrom(
      byte[] data, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }

  public static org.apache.ratis.thirdparty.com.google.rpc.Help parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
  }

  public static org.apache.ratis.thirdparty.com.google.rpc.Help parseFrom(
      java.io.InputStream input, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(
        PARSER, input, extensionRegistry);
  }

  public static org.apache.ratis.thirdparty.com.google.rpc.Help parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(PARSER, input);
  }

  public static org.apache.ratis.thirdparty.com.google.rpc.Help parseDelimitedFrom(
      java.io.InputStream input, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(
        PARSER, input, extensionRegistry);
  }

  public static org.apache.ratis.thirdparty.com.google.rpc.Help parseFrom(org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
  }

  public static org.apache.ratis.thirdparty.com.google.rpc.Help parseFrom(
      org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
      org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(
        PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() {
    return newBuilder();
  }

  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }

  public static Builder newBuilder(org.apache.ratis.thirdparty.com.google.rpc.Help prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }

  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   *
   *
   * <pre>
   * Provides links to documentation or for performing an out of band action.
   * For example, if a quota check failed with an error indicating the calling
   * project hasn't enabled the accessed service, this can contain a URL pointing
   * directly to the right place in the developer console to flip the bit.
   * </pre>
   *
   * Protobuf type {@code google.rpc.Help}
   */
  public static final class Builder extends org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.Builder<Builder>
      implements
      // @@protoc_insertion_point(builder_implements:google.rpc.Help)
      org.apache.ratis.thirdparty.com.google.rpc.HelpOrBuilder {
    public static final org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
      return org.apache.ratis.thirdparty.com.google.rpc.ErrorDetailsProto.internal_static_google_rpc_Help_descriptor;
    }

    @java.lang.Override
    protected org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.apache.ratis.thirdparty.com.google.rpc.ErrorDetailsProto.internal_static_google_rpc_Help_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.apache.ratis.thirdparty.com.google.rpc.Help.class, org.apache.ratis.thirdparty.com.google.rpc.Help.Builder.class);
    }

    // Construct using org.apache.ratis.thirdparty.com.google.rpc.Help.newBuilder()
    private Builder() {
      maybeForceBuilderInitialization();
    }

    private Builder(org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);
      maybeForceBuilderInitialization();
    }

    private void maybeForceBuilderInitialization() {
      if (org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders) {
        getLinksFieldBuilder();
      }
    }

    @java.lang.Override
    public Builder clear() {
      super.clear();
      if (linksBuilder_ == null) {
        links_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000001);
      } else {
        linksBuilder_.clear();
      }
      return this;
    }

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.Descriptor getDescriptorForType() {
      return org.apache.ratis.thirdparty.com.google.rpc.ErrorDetailsProto.internal_static_google_rpc_Help_descriptor;
    }

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.rpc.Help getDefaultInstanceForType() {
      return org.apache.ratis.thirdparty.com.google.rpc.Help.getDefaultInstance();
    }

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.rpc.Help build() {
      org.apache.ratis.thirdparty.com.google.rpc.Help result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.rpc.Help buildPartial() {
      org.apache.ratis.thirdparty.com.google.rpc.Help result = new org.apache.ratis.thirdparty.com.google.rpc.Help(this);
      int from_bitField0_ = bitField0_;
      if (linksBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0)) {
          links_ = java.util.Collections.unmodifiableList(links_);
          bitField0_ = (bitField0_ & ~0x00000001);
        }
        result.links_ = links_;
      } else {
        result.links_ = linksBuilder_.build();
      }
      onBuilt();
      return result;
    }

    @java.lang.Override
    public Builder clone() {
      return super.clone();
    }

    @java.lang.Override
    public Builder setField(
        org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
      return super.setField(field, value);
    }

    @java.lang.Override
    public Builder clearField(org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field) {
      return super.clearField(field);
    }

    @java.lang.Override
    public Builder clearOneof(org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.OneofDescriptor oneof) {
      return super.clearOneof(oneof);
    }

    @java.lang.Override
    public Builder setRepeatedField(
        org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field, int index, java.lang.Object value) {
      return super.setRepeatedField(field, index, value);
    }

    @java.lang.Override
    public Builder addRepeatedField(
        org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
      return super.addRepeatedField(field, value);
    }

    @java.lang.Override
    public Builder mergeFrom(org.apache.ratis.thirdparty.com.google.protobuf.Message other) {
      if (other instanceof org.apache.ratis.thirdparty.com.google.rpc.Help) {
        return mergeFrom((org.apache.ratis.thirdparty.com.google.rpc.Help) other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(org.apache.ratis.thirdparty.com.google.rpc.Help other) {
      if (other == org.apache.ratis.thirdparty.com.google.rpc.Help.getDefaultInstance()) return this;
      if (linksBuilder_ == null) {
        if (!other.links_.isEmpty()) {
          if (links_.isEmpty()) {
            links_ = other.links_;
            bitField0_ = (bitField0_ & ~0x00000001);
          } else {
            ensureLinksIsMutable();
            links_.addAll(other.links_);
          }
          onChanged();
        }
      } else {
        if (!other.links_.isEmpty()) {
          if (linksBuilder_.isEmpty()) {
            linksBuilder_.dispose();
            linksBuilder_ = null;
            links_ = other.links_;
            bitField0_ = (bitField0_ & ~0x00000001);
            linksBuilder_ =
                org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders
                    ? getLinksFieldBuilder()
                    : null;
          } else {
            linksBuilder_.addAllMessages(other.links_);
          }
        }
      }
      this.mergeUnknownFields(other.unknownFields);
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
        org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      org.apache.ratis.thirdparty.com.google.rpc.Help parsedMessage = null;
      try {
        parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
      } catch (org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException e) {
        parsedMessage = (org.apache.ratis.thirdparty.com.google.rpc.Help) e.getUnfinishedMessage();
        throw e.unwrapIOException();
      } finally {
        if (parsedMessage != null) {
          mergeFrom(parsedMessage);
        }
      }
      return this;
    }

    private int bitField0_;

    private java.util.List<org.apache.ratis.thirdparty.com.google.rpc.Help.Link> links_ = java.util.Collections.emptyList();

    private void ensureLinksIsMutable() {
      if (!((bitField0_ & 0x00000001) != 0)) {
        links_ = new java.util.ArrayList<org.apache.ratis.thirdparty.com.google.rpc.Help.Link>(links_);
        bitField0_ |= 0x00000001;
      }
    }

    private org.apache.ratis.thirdparty.com.google.protobuf.RepeatedFieldBuilderV3<
            org.apache.ratis.thirdparty.com.google.rpc.Help.Link,
            org.apache.ratis.thirdparty.com.google.rpc.Help.Link.Builder,
            org.apache.ratis.thirdparty.com.google.rpc.Help.LinkOrBuilder>
        linksBuilder_;

    /**
     *
     *
     * <pre>
     * URL(s) pointing to additional information on handling the current error.
     * </pre>
     *
     * <code>repeated .google.rpc.Help.Link links = 1;</code>
     */
    public java.util.List<org.apache.ratis.thirdparty.com.google.rpc.Help.Link> getLinksList() {
      if (linksBuilder_ == null) {
        return java.util.Collections.unmodifiableList(links_);
      } else {
        return linksBuilder_.getMessageList();
      }
    }
    /**
     *
     *
     * <pre>
     * URL(s) pointing to additional information on handling the current error.
     * </pre>
     *
     * <code>repeated .google.rpc.Help.Link links = 1;</code>
     */
    public int getLinksCount() {
      if (linksBuilder_ == null) {
        return links_.size();
      } else {
        return linksBuilder_.getCount();
      }
    }
    /**
     *
     *
     * <pre>
     * URL(s) pointing to additional information on handling the current error.
     * </pre>
     *
     * <code>repeated .google.rpc.Help.Link links = 1;</code>
     */
    public org.apache.ratis.thirdparty.com.google.rpc.Help.Link getLinks(int index) {
      if (linksBuilder_ == null) {
        return links_.get(index);
      } else {
        return linksBuilder_.getMessage(index);
      }
    }
    /**
     *
     *
     * <pre>
     * URL(s) pointing to additional information on handling the current error.
     * </pre>
     *
     * <code>repeated .google.rpc.Help.Link links = 1;</code>
     */
    public Builder setLinks(int index, org.apache.ratis.thirdparty.com.google.rpc.Help.Link value) {
      if (linksBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureLinksIsMutable();
        links_.set(index, value);
        onChanged();
      } else {
        linksBuilder_.setMessage(index, value);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * URL(s) pointing to additional information on handling the current error.
     * </pre>
     *
     * <code>repeated .google.rpc.Help.Link links = 1;</code>
     */
    public Builder setLinks(int index, org.apache.ratis.thirdparty.com.google.rpc.Help.Link.Builder builderForValue) {
      if (linksBuilder_ == null) {
        ensureLinksIsMutable();
        links_.set(index, builderForValue.build());
        onChanged();
      } else {
        linksBuilder_.setMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * URL(s) pointing to additional information on handling the current error.
     * </pre>
     *
     * <code>repeated .google.rpc.Help.Link links = 1;</code>
     */
    public Builder addLinks(org.apache.ratis.thirdparty.com.google.rpc.Help.Link value) {
      if (linksBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureLinksIsMutable();
        links_.add(value);
        onChanged();
      } else {
        linksBuilder_.addMessage(value);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * URL(s) pointing to additional information on handling the current error.
     * </pre>
     *
     * <code>repeated .google.rpc.Help.Link links = 1;</code>
     */
    public Builder addLinks(int index, org.apache.ratis.thirdparty.com.google.rpc.Help.Link value) {
      if (linksBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureLinksIsMutable();
        links_.add(index, value);
        onChanged();
      } else {
        linksBuilder_.addMessage(index, value);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * URL(s) pointing to additional information on handling the current error.
     * </pre>
     *
     * <code>repeated .google.rpc.Help.Link links = 1;</code>
     */
    public Builder addLinks(org.apache.ratis.thirdparty.com.google.rpc.Help.Link.Builder builderForValue) {
      if (linksBuilder_ == null) {
        ensureLinksIsMutable();
        links_.add(builderForValue.build());
        onChanged();
      } else {
        linksBuilder_.addMessage(builderForValue.build());
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * URL(s) pointing to additional information on handling the current error.
     * </pre>
     *
     * <code>repeated .google.rpc.Help.Link links = 1;</code>
     */
    public Builder addLinks(int index, org.apache.ratis.thirdparty.com.google.rpc.Help.Link.Builder builderForValue) {
      if (linksBuilder_ == null) {
        ensureLinksIsMutable();
        links_.add(index, builderForValue.build());
        onChanged();
      } else {
        linksBuilder_.addMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * URL(s) pointing to additional information on handling the current error.
     * </pre>
     *
     * <code>repeated .google.rpc.Help.Link links = 1;</code>
     */
    public Builder addAllLinks(java.lang.Iterable<? extends org.apache.ratis.thirdparty.com.google.rpc.Help.Link> values) {
      if (linksBuilder_ == null) {
        ensureLinksIsMutable();
        org.apache.ratis.thirdparty.com.google.protobuf.AbstractMessageLite.Builder.addAll(values, links_);
        onChanged();
      } else {
        linksBuilder_.addAllMessages(values);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * URL(s) pointing to additional information on handling the current error.
     * </pre>
     *
     * <code>repeated .google.rpc.Help.Link links = 1;</code>
     */
    public Builder clearLinks() {
      if (linksBuilder_ == null) {
        links_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000001);
        onChanged();
      } else {
        linksBuilder_.clear();
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * URL(s) pointing to additional information on handling the current error.
     * </pre>
     *
     * <code>repeated .google.rpc.Help.Link links = 1;</code>
     */
    public Builder removeLinks(int index) {
      if (linksBuilder_ == null) {
        ensureLinksIsMutable();
        links_.remove(index);
        onChanged();
      } else {
        linksBuilder_.remove(index);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * URL(s) pointing to additional information on handling the current error.
     * </pre>
     *
     * <code>repeated .google.rpc.Help.Link links = 1;</code>
     */
    public org.apache.ratis.thirdparty.com.google.rpc.Help.Link.Builder getLinksBuilder(int index) {
      return getLinksFieldBuilder().getBuilder(index);
    }
    /**
     *
     *
     * <pre>
     * URL(s) pointing to additional information on handling the current error.
     * </pre>
     *
     * <code>repeated .google.rpc.Help.Link links = 1;</code>
     */
    public org.apache.ratis.thirdparty.com.google.rpc.Help.LinkOrBuilder getLinksOrBuilder(int index) {
      if (linksBuilder_ == null) {
        return links_.get(index);
      } else {
        return linksBuilder_.getMessageOrBuilder(index);
      }
    }
    /**
     *
     *
     * <pre>
     * URL(s) pointing to additional information on handling the current error.
     * </pre>
     *
     * <code>repeated .google.rpc.Help.Link links = 1;</code>
     */
    public java.util.List<? extends org.apache.ratis.thirdparty.com.google.rpc.Help.LinkOrBuilder> getLinksOrBuilderList() {
      if (linksBuilder_ != null) {
        return linksBuilder_.getMessageOrBuilderList();
      } else {
        return java.util.Collections.unmodifiableList(links_);
      }
    }
    /**
     *
     *
     * <pre>
     * URL(s) pointing to additional information on handling the current error.
     * </pre>
     *
     * <code>repeated .google.rpc.Help.Link links = 1;</code>
     */
    public org.apache.ratis.thirdparty.com.google.rpc.Help.Link.Builder addLinksBuilder() {
      return getLinksFieldBuilder().addBuilder(org.apache.ratis.thirdparty.com.google.rpc.Help.Link.getDefaultInstance());
    }
    /**
     *
     *
     * <pre>
     * URL(s) pointing to additional information on handling the current error.
     * </pre>
     *
     * <code>repeated .google.rpc.Help.Link links = 1;</code>
     */
    public org.apache.ratis.thirdparty.com.google.rpc.Help.Link.Builder addLinksBuilder(int index) {
      return getLinksFieldBuilder()
          .addBuilder(index, org.apache.ratis.thirdparty.com.google.rpc.Help.Link.getDefaultInstance());
    }
    /**
     *
     *
     * <pre>
     * URL(s) pointing to additional information on handling the current error.
     * </pre>
     *
     * <code>repeated .google.rpc.Help.Link links = 1;</code>
     */
    public java.util.List<org.apache.ratis.thirdparty.com.google.rpc.Help.Link.Builder> getLinksBuilderList() {
      return getLinksFieldBuilder().getBuilderList();
    }

    private org.apache.ratis.thirdparty.com.google.protobuf.RepeatedFieldBuilderV3<
            org.apache.ratis.thirdparty.com.google.rpc.Help.Link,
            org.apache.ratis.thirdparty.com.google.rpc.Help.Link.Builder,
            org.apache.ratis.thirdparty.com.google.rpc.Help.LinkOrBuilder>
        getLinksFieldBuilder() {
      if (linksBuilder_ == null) {
        linksBuilder_ =
            new org.apache.ratis.thirdparty.com.google.protobuf.RepeatedFieldBuilderV3<
                org.apache.ratis.thirdparty.com.google.rpc.Help.Link,
                org.apache.ratis.thirdparty.com.google.rpc.Help.Link.Builder,
                org.apache.ratis.thirdparty.com.google.rpc.Help.LinkOrBuilder>(
                links_, ((bitField0_ & 0x00000001) != 0), getParentForChildren(), isClean());
        links_ = null;
      }
      return linksBuilder_;
    }

    @java.lang.Override
    public final Builder setUnknownFields(final org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }

    // @@protoc_insertion_point(builder_scope:google.rpc.Help)
  }

  // @@protoc_insertion_point(class_scope:google.rpc.Help)
  private static final org.apache.ratis.thirdparty.com.google.rpc.Help DEFAULT_INSTANCE;

  static {
    DEFAULT_INSTANCE = new org.apache.ratis.thirdparty.com.google.rpc.Help();
  }

  public static org.apache.ratis.thirdparty.com.google.rpc.Help getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final org.apache.ratis.thirdparty.com.google.protobuf.Parser<Help> PARSER =
      new org.apache.ratis.thirdparty.com.google.protobuf.AbstractParser<Help>() {
        @java.lang.Override
        public Help parsePartialFrom(
            org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
            org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
          return new Help(input, extensionRegistry);
        }
      };

  public static org.apache.ratis.thirdparty.com.google.protobuf.Parser<Help> parser() {
    return PARSER;
  }

  @java.lang.Override
  public org.apache.ratis.thirdparty.com.google.protobuf.Parser<Help> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public org.apache.ratis.thirdparty.com.google.rpc.Help getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }
}
