/*
 * Copyright 2020 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: google/rpc/error_details.proto

package org.apache.ratis.thirdparty.com.google.rpc;

/**
 *
 *
 * <pre>
 * Describes what preconditions have failed.
 * For example, if an RPC failed because it required the Terms of Service to be
 * acknowledged, it could list the terms of service violation in the
 * PreconditionFailure message.
 * </pre>
 *
 * Protobuf type {@code google.rpc.PreconditionFailure}
 */
public final class PreconditionFailure extends org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3
    implements
    // @@protoc_insertion_point(message_implements:google.rpc.PreconditionFailure)
    PreconditionFailureOrBuilder {
  private static final long serialVersionUID = 0L;
  // Use PreconditionFailure.newBuilder() to construct.
  private PreconditionFailure(org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }

  private PreconditionFailure() {
    violations_ = java.util.Collections.emptyList();
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(UnusedPrivateParameter unused) {
    return new PreconditionFailure();
  }

  @java.lang.Override
  public final org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet getUnknownFields() {
    return this.unknownFields;
  }

  private PreconditionFailure(
      org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
      org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    this();
    if (extensionRegistry == null) {
      throw new java.lang.NullPointerException();
    }
    int mutable_bitField0_ = 0;
    org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet.Builder unknownFields =
        org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet.newBuilder();
    try {
      boolean done = false;
      while (!done) {
        int tag = input.readTag();
        switch (tag) {
          case 0:
            done = true;
            break;
          case 10:
            {
              if (!((mutable_bitField0_ & 0x00000001) != 0)) {
                violations_ =
                    new java.util.ArrayList<org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation>();
                mutable_bitField0_ |= 0x00000001;
              }
              violations_.add(
                  input.readMessage(
                      org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation.parser(), extensionRegistry));
              break;
            }
          default:
            {
              if (!parseUnknownField(input, unknownFields, extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
        }
      }
    } catch (org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException e) {
      throw e.setUnfinishedMessage(this);
    } catch (java.io.IOException e) {
      throw new org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException(e).setUnfinishedMessage(this);
    } finally {
      if (((mutable_bitField0_ & 0x00000001) != 0)) {
        violations_ = java.util.Collections.unmodifiableList(violations_);
      }
      this.unknownFields = unknownFields.build();
      makeExtensionsImmutable();
    }
  }

  public static final org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
    return org.apache.ratis.thirdparty.com.google.rpc.ErrorDetailsProto
        .internal_static_google_rpc_PreconditionFailure_descriptor;
  }

  @java.lang.Override
  protected org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return org.apache.ratis.thirdparty.com.google.rpc.ErrorDetailsProto
        .internal_static_google_rpc_PreconditionFailure_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.class,
            org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Builder.class);
  }

  public interface ViolationOrBuilder
      extends
      // @@protoc_insertion_point(interface_extends:google.rpc.PreconditionFailure.Violation)
      org.apache.ratis.thirdparty.com.google.protobuf.MessageOrBuilder {

    /**
     *
     *
     * <pre>
     * The type of PreconditionFailure. We recommend using a service-specific
     * enum type to define the supported precondition violation subjects. For
     * example, "TOS" for "Terms of Service violation".
     * </pre>
     *
     * <code>string type = 1;</code>
     *
     * @return The type.
     */
    java.lang.String getType();
    /**
     *
     *
     * <pre>
     * The type of PreconditionFailure. We recommend using a service-specific
     * enum type to define the supported precondition violation subjects. For
     * example, "TOS" for "Terms of Service violation".
     * </pre>
     *
     * <code>string type = 1;</code>
     *
     * @return The bytes for type.
     */
    org.apache.ratis.thirdparty.com.google.protobuf.ByteString getTypeBytes();

    /**
     *
     *
     * <pre>
     * The subject, relative to the type, that failed.
     * For example, "google.com/cloud" relative to the "TOS" type would indicate
     * which terms of service is being referenced.
     * </pre>
     *
     * <code>string subject = 2;</code>
     *
     * @return The subject.
     */
    java.lang.String getSubject();
    /**
     *
     *
     * <pre>
     * The subject, relative to the type, that failed.
     * For example, "google.com/cloud" relative to the "TOS" type would indicate
     * which terms of service is being referenced.
     * </pre>
     *
     * <code>string subject = 2;</code>
     *
     * @return The bytes for subject.
     */
    org.apache.ratis.thirdparty.com.google.protobuf.ByteString getSubjectBytes();

    /**
     *
     *
     * <pre>
     * A description of how the precondition failed. Developers can use this
     * description to understand how to fix the failure.
     * For example: "Terms of service not accepted".
     * </pre>
     *
     * <code>string description = 3;</code>
     *
     * @return The description.
     */
    java.lang.String getDescription();
    /**
     *
     *
     * <pre>
     * A description of how the precondition failed. Developers can use this
     * description to understand how to fix the failure.
     * For example: "Terms of service not accepted".
     * </pre>
     *
     * <code>string description = 3;</code>
     *
     * @return The bytes for description.
     */
    org.apache.ratis.thirdparty.com.google.protobuf.ByteString getDescriptionBytes();
  }
  /**
   *
   *
   * <pre>
   * A message type used to describe a single precondition failure.
   * </pre>
   *
   * Protobuf type {@code google.rpc.PreconditionFailure.Violation}
   */
  public static final class Violation extends org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3
      implements
      // @@protoc_insertion_point(message_implements:google.rpc.PreconditionFailure.Violation)
      ViolationOrBuilder {
    private static final long serialVersionUID = 0L;
    // Use Violation.newBuilder() to construct.
    private Violation(org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }

    private Violation() {
      type_ = "";
      subject_ = "";
      description_ = "";
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(UnusedPrivateParameter unused) {
      return new Violation();
    }

    @java.lang.Override
    public final org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet getUnknownFields() {
      return this.unknownFields;
    }

    private Violation(
        org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
        org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
      this();
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10:
              {
                java.lang.String s = input.readStringRequireUtf8();

                type_ = s;
                break;
              }
            case 18:
              {
                java.lang.String s = input.readStringRequireUtf8();

                subject_ = s;
                break;
              }
            case 26:
              {
                java.lang.String s = input.readStringRequireUtf8();

                description_ = s;
                break;
              }
            default:
              {
                if (!parseUnknownField(input, unknownFields, extensionRegistry, tag)) {
                  done = true;
                }
                break;
              }
          }
        }
      } catch (org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException(e).setUnfinishedMessage(this);
      } finally {
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }

    public static final org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
      return org.apache.ratis.thirdparty.com.google.rpc.ErrorDetailsProto
          .internal_static_google_rpc_PreconditionFailure_Violation_descriptor;
    }

    @java.lang.Override
    protected org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.apache.ratis.thirdparty.com.google.rpc.ErrorDetailsProto
          .internal_static_google_rpc_PreconditionFailure_Violation_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation.class,
              org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation.Builder.class);
    }

    public static final int TYPE_FIELD_NUMBER = 1;
    private volatile java.lang.Object type_;
    /**
     *
     *
     * <pre>
     * The type of PreconditionFailure. We recommend using a service-specific
     * enum type to define the supported precondition violation subjects. For
     * example, "TOS" for "Terms of Service violation".
     * </pre>
     *
     * <code>string type = 1;</code>
     *
     * @return The type.
     */
    @java.lang.Override
    public java.lang.String getType() {
      java.lang.Object ref = type_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        org.apache.ratis.thirdparty.com.google.protobuf.ByteString bs = (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        type_ = s;
        return s;
      }
    }
    /**
     *
     *
     * <pre>
     * The type of PreconditionFailure. We recommend using a service-specific
     * enum type to define the supported precondition violation subjects. For
     * example, "TOS" for "Terms of Service violation".
     * </pre>
     *
     * <code>string type = 1;</code>
     *
     * @return The bytes for type.
     */
    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.protobuf.ByteString getTypeBytes() {
      java.lang.Object ref = type_;
      if (ref instanceof java.lang.String) {
        org.apache.ratis.thirdparty.com.google.protobuf.ByteString b =
            org.apache.ratis.thirdparty.com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
        type_ = b;
        return b;
      } else {
        return (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
      }
    }

    public static final int SUBJECT_FIELD_NUMBER = 2;
    private volatile java.lang.Object subject_;
    /**
     *
     *
     * <pre>
     * The subject, relative to the type, that failed.
     * For example, "google.com/cloud" relative to the "TOS" type would indicate
     * which terms of service is being referenced.
     * </pre>
     *
     * <code>string subject = 2;</code>
     *
     * @return The subject.
     */
    @java.lang.Override
    public java.lang.String getSubject() {
      java.lang.Object ref = subject_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        org.apache.ratis.thirdparty.com.google.protobuf.ByteString bs = (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        subject_ = s;
        return s;
      }
    }
    /**
     *
     *
     * <pre>
     * The subject, relative to the type, that failed.
     * For example, "google.com/cloud" relative to the "TOS" type would indicate
     * which terms of service is being referenced.
     * </pre>
     *
     * <code>string subject = 2;</code>
     *
     * @return The bytes for subject.
     */
    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.protobuf.ByteString getSubjectBytes() {
      java.lang.Object ref = subject_;
      if (ref instanceof java.lang.String) {
        org.apache.ratis.thirdparty.com.google.protobuf.ByteString b =
            org.apache.ratis.thirdparty.com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
        subject_ = b;
        return b;
      } else {
        return (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
      }
    }

    public static final int DESCRIPTION_FIELD_NUMBER = 3;
    private volatile java.lang.Object description_;
    /**
     *
     *
     * <pre>
     * A description of how the precondition failed. Developers can use this
     * description to understand how to fix the failure.
     * For example: "Terms of service not accepted".
     * </pre>
     *
     * <code>string description = 3;</code>
     *
     * @return The description.
     */
    @java.lang.Override
    public java.lang.String getDescription() {
      java.lang.Object ref = description_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        org.apache.ratis.thirdparty.com.google.protobuf.ByteString bs = (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        description_ = s;
        return s;
      }
    }
    /**
     *
     *
     * <pre>
     * A description of how the precondition failed. Developers can use this
     * description to understand how to fix the failure.
     * For example: "Terms of service not accepted".
     * </pre>
     *
     * <code>string description = 3;</code>
     *
     * @return The bytes for description.
     */
    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.protobuf.ByteString getDescriptionBytes() {
      java.lang.Object ref = description_;
      if (ref instanceof java.lang.String) {
        org.apache.ratis.thirdparty.com.google.protobuf.ByteString b =
            org.apache.ratis.thirdparty.com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
        description_ = b;
        return b;
      } else {
        return (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
      }
    }

    private byte memoizedIsInitialized = -1;

    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(org.apache.ratis.thirdparty.com.google.protobuf.CodedOutputStream output) throws java.io.IOException {
      if (!getTypeBytes().isEmpty()) {
        org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.writeString(output, 1, type_);
      }
      if (!getSubjectBytes().isEmpty()) {
        org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.writeString(output, 2, subject_);
      }
      if (!getDescriptionBytes().isEmpty()) {
        org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.writeString(output, 3, description_);
      }
      unknownFields.writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (!getTypeBytes().isEmpty()) {
        size += org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.computeStringSize(1, type_);
      }
      if (!getSubjectBytes().isEmpty()) {
        size += org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.computeStringSize(2, subject_);
      }
      if (!getDescriptionBytes().isEmpty()) {
        size += org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.computeStringSize(3, description_);
      }
      size += unknownFields.getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
        return true;
      }
      if (!(obj instanceof org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation)) {
        return super.equals(obj);
      }
      org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation other =
          (org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation) obj;

      if (!getType().equals(other.getType())) return false;
      if (!getSubject().equals(other.getSubject())) return false;
      if (!getDescription().equals(other.getDescription())) return false;
      if (!unknownFields.equals(other.unknownFields)) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      hash = (37 * hash) + TYPE_FIELD_NUMBER;
      hash = (53 * hash) + getType().hashCode();
      hash = (37 * hash) + SUBJECT_FIELD_NUMBER;
      hash = (53 * hash) + getSubject().hashCode();
      hash = (37 * hash) + DESCRIPTION_FIELD_NUMBER;
      hash = (53 * hash) + getDescription().hashCode();
      hash = (29 * hash) + unknownFields.hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation parseFrom(java.nio.ByteBuffer data)
        throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }

    public static org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation parseFrom(
        java.nio.ByteBuffer data, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }

    public static org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation parseFrom(
        org.apache.ratis.thirdparty.com.google.protobuf.ByteString data)
        throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }

    public static org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation parseFrom(
        org.apache.ratis.thirdparty.com.google.protobuf.ByteString data,
        org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }

    public static org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation parseFrom(byte[] data)
        throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }

    public static org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation parseFrom(
        byte[] data, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }

    public static org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
    }

    public static org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation parseFrom(
        java.io.InputStream input, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(
          PARSER, input, extensionRegistry);
    }

    public static org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation parseDelimitedFrom(
        java.io.InputStream input) throws java.io.IOException {
      return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(PARSER, input);
    }

    public static org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation parseDelimitedFrom(
        java.io.InputStream input, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(
          PARSER, input, extensionRegistry);
    }

    public static org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation parseFrom(
        org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input) throws java.io.IOException {
      return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
    }

    public static org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation parseFrom(
        org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
        org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(
          PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() {
      return newBuilder();
    }

    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }

    public static Builder newBuilder(org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }

    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     *
     *
     * <pre>
     * A message type used to describe a single precondition failure.
     * </pre>
     *
     * Protobuf type {@code google.rpc.PreconditionFailure.Violation}
     */
    public static final class Builder
        extends org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.Builder<Builder>
        implements
        // @@protoc_insertion_point(builder_implements:google.rpc.PreconditionFailure.Violation)
        org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.ViolationOrBuilder {
      public static final org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
        return org.apache.ratis.thirdparty.com.google.rpc.ErrorDetailsProto
            .internal_static_google_rpc_PreconditionFailure_Violation_descriptor;
      }

      @java.lang.Override
      protected org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.apache.ratis.thirdparty.com.google.rpc.ErrorDetailsProto
            .internal_static_google_rpc_PreconditionFailure_Violation_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation.class,
                org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation.Builder.class);
      }

      // Construct using org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }

      private void maybeForceBuilderInitialization() {
        if (org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders) {}
      }

      @java.lang.Override
      public Builder clear() {
        super.clear();
        type_ = "";

        subject_ = "";

        description_ = "";

        return this;
      }

      @java.lang.Override
      public org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.Descriptor getDescriptorForType() {
        return org.apache.ratis.thirdparty.com.google.rpc.ErrorDetailsProto
            .internal_static_google_rpc_PreconditionFailure_Violation_descriptor;
      }

      @java.lang.Override
      public org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation getDefaultInstanceForType() {
        return org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation.getDefaultInstance();
      }

      @java.lang.Override
      public org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation build() {
        org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation buildPartial() {
        org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation result =
            new org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation(this);
        result.type_ = type_;
        result.subject_ = subject_;
        result.description_ = description_;
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }

      @java.lang.Override
      public Builder setField(
          org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
        return super.setField(field, value);
      }

      @java.lang.Override
      public Builder clearField(org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }

      @java.lang.Override
      public Builder clearOneof(org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }

      @java.lang.Override
      public Builder setRepeatedField(
          org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field,
          int index,
          java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }

      @java.lang.Override
      public Builder addRepeatedField(
          org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }

      @java.lang.Override
      public Builder mergeFrom(org.apache.ratis.thirdparty.com.google.protobuf.Message other) {
        if (other instanceof org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation) {
          return mergeFrom((org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation) other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation other) {
        if (other == org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation.getDefaultInstance()) return this;
        if (!other.getType().isEmpty()) {
          type_ = other.type_;
          onChanged();
        }
        if (!other.getSubject().isEmpty()) {
          subject_ = other.subject_;
          onChanged();
        }
        if (!other.getDescription().isEmpty()) {
          description_ = other.description_;
          onChanged();
        }
        this.mergeUnknownFields(other.unknownFields);
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
          org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException e) {
          parsedMessage = (org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation) e.getUnfinishedMessage();
          throw e.unwrapIOException();
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }

      private java.lang.Object type_ = "";
      /**
       *
       *
       * <pre>
       * The type of PreconditionFailure. We recommend using a service-specific
       * enum type to define the supported precondition violation subjects. For
       * example, "TOS" for "Terms of Service violation".
       * </pre>
       *
       * <code>string type = 1;</code>
       *
       * @return The type.
       */
      public java.lang.String getType() {
        java.lang.Object ref = type_;
        if (!(ref instanceof java.lang.String)) {
          org.apache.ratis.thirdparty.com.google.protobuf.ByteString bs = (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          type_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The type of PreconditionFailure. We recommend using a service-specific
       * enum type to define the supported precondition violation subjects. For
       * example, "TOS" for "Terms of Service violation".
       * </pre>
       *
       * <code>string type = 1;</code>
       *
       * @return The bytes for type.
       */
      public org.apache.ratis.thirdparty.com.google.protobuf.ByteString getTypeBytes() {
        java.lang.Object ref = type_;
        if (ref instanceof String) {
          org.apache.ratis.thirdparty.com.google.protobuf.ByteString b =
              org.apache.ratis.thirdparty.com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
          type_ = b;
          return b;
        } else {
          return (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The type of PreconditionFailure. We recommend using a service-specific
       * enum type to define the supported precondition violation subjects. For
       * example, "TOS" for "Terms of Service violation".
       * </pre>
       *
       * <code>string type = 1;</code>
       *
       * @param value The type to set.
       * @return This builder for chaining.
       */
      public Builder setType(java.lang.String value) {
        if (value == null) {
          throw new NullPointerException();
        }

        type_ = value;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The type of PreconditionFailure. We recommend using a service-specific
       * enum type to define the supported precondition violation subjects. For
       * example, "TOS" for "Terms of Service violation".
       * </pre>
       *
       * <code>string type = 1;</code>
       *
       * @return This builder for chaining.
       */
      public Builder clearType() {

        type_ = getDefaultInstance().getType();
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The type of PreconditionFailure. We recommend using a service-specific
       * enum type to define the supported precondition violation subjects. For
       * example, "TOS" for "Terms of Service violation".
       * </pre>
       *
       * <code>string type = 1;</code>
       *
       * @param value The bytes for type to set.
       * @return This builder for chaining.
       */
      public Builder setTypeBytes(org.apache.ratis.thirdparty.com.google.protobuf.ByteString value) {
        if (value == null) {
          throw new NullPointerException();
        }
        checkByteStringIsUtf8(value);

        type_ = value;
        onChanged();
        return this;
      }

      private java.lang.Object subject_ = "";
      /**
       *
       *
       * <pre>
       * The subject, relative to the type, that failed.
       * For example, "google.com/cloud" relative to the "TOS" type would indicate
       * which terms of service is being referenced.
       * </pre>
       *
       * <code>string subject = 2;</code>
       *
       * @return The subject.
       */
      public java.lang.String getSubject() {
        java.lang.Object ref = subject_;
        if (!(ref instanceof java.lang.String)) {
          org.apache.ratis.thirdparty.com.google.protobuf.ByteString bs = (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          subject_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The subject, relative to the type, that failed.
       * For example, "google.com/cloud" relative to the "TOS" type would indicate
       * which terms of service is being referenced.
       * </pre>
       *
       * <code>string subject = 2;</code>
       *
       * @return The bytes for subject.
       */
      public org.apache.ratis.thirdparty.com.google.protobuf.ByteString getSubjectBytes() {
        java.lang.Object ref = subject_;
        if (ref instanceof String) {
          org.apache.ratis.thirdparty.com.google.protobuf.ByteString b =
              org.apache.ratis.thirdparty.com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
          subject_ = b;
          return b;
        } else {
          return (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The subject, relative to the type, that failed.
       * For example, "google.com/cloud" relative to the "TOS" type would indicate
       * which terms of service is being referenced.
       * </pre>
       *
       * <code>string subject = 2;</code>
       *
       * @param value The subject to set.
       * @return This builder for chaining.
       */
      public Builder setSubject(java.lang.String value) {
        if (value == null) {
          throw new NullPointerException();
        }

        subject_ = value;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The subject, relative to the type, that failed.
       * For example, "google.com/cloud" relative to the "TOS" type would indicate
       * which terms of service is being referenced.
       * </pre>
       *
       * <code>string subject = 2;</code>
       *
       * @return This builder for chaining.
       */
      public Builder clearSubject() {

        subject_ = getDefaultInstance().getSubject();
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The subject, relative to the type, that failed.
       * For example, "google.com/cloud" relative to the "TOS" type would indicate
       * which terms of service is being referenced.
       * </pre>
       *
       * <code>string subject = 2;</code>
       *
       * @param value The bytes for subject to set.
       * @return This builder for chaining.
       */
      public Builder setSubjectBytes(org.apache.ratis.thirdparty.com.google.protobuf.ByteString value) {
        if (value == null) {
          throw new NullPointerException();
        }
        checkByteStringIsUtf8(value);

        subject_ = value;
        onChanged();
        return this;
      }

      private java.lang.Object description_ = "";
      /**
       *
       *
       * <pre>
       * A description of how the precondition failed. Developers can use this
       * description to understand how to fix the failure.
       * For example: "Terms of service not accepted".
       * </pre>
       *
       * <code>string description = 3;</code>
       *
       * @return The description.
       */
      public java.lang.String getDescription() {
        java.lang.Object ref = description_;
        if (!(ref instanceof java.lang.String)) {
          org.apache.ratis.thirdparty.com.google.protobuf.ByteString bs = (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          description_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * A description of how the precondition failed. Developers can use this
       * description to understand how to fix the failure.
       * For example: "Terms of service not accepted".
       * </pre>
       *
       * <code>string description = 3;</code>
       *
       * @return The bytes for description.
       */
      public org.apache.ratis.thirdparty.com.google.protobuf.ByteString getDescriptionBytes() {
        java.lang.Object ref = description_;
        if (ref instanceof String) {
          org.apache.ratis.thirdparty.com.google.protobuf.ByteString b =
              org.apache.ratis.thirdparty.com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
          description_ = b;
          return b;
        } else {
          return (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * A description of how the precondition failed. Developers can use this
       * description to understand how to fix the failure.
       * For example: "Terms of service not accepted".
       * </pre>
       *
       * <code>string description = 3;</code>
       *
       * @param value The description to set.
       * @return This builder for chaining.
       */
      public Builder setDescription(java.lang.String value) {
        if (value == null) {
          throw new NullPointerException();
        }

        description_ = value;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * A description of how the precondition failed. Developers can use this
       * description to understand how to fix the failure.
       * For example: "Terms of service not accepted".
       * </pre>
       *
       * <code>string description = 3;</code>
       *
       * @return This builder for chaining.
       */
      public Builder clearDescription() {

        description_ = getDefaultInstance().getDescription();
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * A description of how the precondition failed. Developers can use this
       * description to understand how to fix the failure.
       * For example: "Terms of service not accepted".
       * </pre>
       *
       * <code>string description = 3;</code>
       *
       * @param value The bytes for description to set.
       * @return This builder for chaining.
       */
      public Builder setDescriptionBytes(org.apache.ratis.thirdparty.com.google.protobuf.ByteString value) {
        if (value == null) {
          throw new NullPointerException();
        }
        checkByteStringIsUtf8(value);

        description_ = value;
        onChanged();
        return this;
      }

      @java.lang.Override
      public final Builder setUnknownFields(
          final org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }

      // @@protoc_insertion_point(builder_scope:google.rpc.PreconditionFailure.Violation)
    }

    // @@protoc_insertion_point(class_scope:google.rpc.PreconditionFailure.Violation)
    private static final org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation DEFAULT_INSTANCE;

    static {
      DEFAULT_INSTANCE = new org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation();
    }

    public static org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final org.apache.ratis.thirdparty.com.google.protobuf.Parser<Violation> PARSER =
        new org.apache.ratis.thirdparty.com.google.protobuf.AbstractParser<Violation>() {
          @java.lang.Override
          public Violation parsePartialFrom(
              org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
              org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
              throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
            return new Violation(input, extensionRegistry);
          }
        };

    public static org.apache.ratis.thirdparty.com.google.protobuf.Parser<Violation> parser() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.protobuf.Parser<Violation> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }
  }

  public static final int VIOLATIONS_FIELD_NUMBER = 1;
  private java.util.List<org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation> violations_;
  /**
   *
   *
   * <pre>
   * Describes all precondition violations.
   * </pre>
   *
   * <code>repeated .google.rpc.PreconditionFailure.Violation violations = 1;</code>
   */
  @java.lang.Override
  public java.util.List<org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation> getViolationsList() {
    return violations_;
  }
  /**
   *
   *
   * <pre>
   * Describes all precondition violations.
   * </pre>
   *
   * <code>repeated .google.rpc.PreconditionFailure.Violation violations = 1;</code>
   */
  @java.lang.Override
  public java.util.List<? extends org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.ViolationOrBuilder>
      getViolationsOrBuilderList() {
    return violations_;
  }
  /**
   *
   *
   * <pre>
   * Describes all precondition violations.
   * </pre>
   *
   * <code>repeated .google.rpc.PreconditionFailure.Violation violations = 1;</code>
   */
  @java.lang.Override
  public int getViolationsCount() {
    return violations_.size();
  }
  /**
   *
   *
   * <pre>
   * Describes all precondition violations.
   * </pre>
   *
   * <code>repeated .google.rpc.PreconditionFailure.Violation violations = 1;</code>
   */
  @java.lang.Override
  public org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation getViolations(int index) {
    return violations_.get(index);
  }
  /**
   *
   *
   * <pre>
   * Describes all precondition violations.
   * </pre>
   *
   * <code>repeated .google.rpc.PreconditionFailure.Violation violations = 1;</code>
   */
  @java.lang.Override
  public org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.ViolationOrBuilder getViolationsOrBuilder(int index) {
    return violations_.get(index);
  }

  private byte memoizedIsInitialized = -1;

  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(org.apache.ratis.thirdparty.com.google.protobuf.CodedOutputStream output) throws java.io.IOException {
    for (int i = 0; i < violations_.size(); i++) {
      output.writeMessage(1, violations_.get(i));
    }
    unknownFields.writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    for (int i = 0; i < violations_.size(); i++) {
      size += org.apache.ratis.thirdparty.com.google.protobuf.CodedOutputStream.computeMessageSize(1, violations_.get(i));
    }
    size += unknownFields.getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
      return true;
    }
    if (!(obj instanceof org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure)) {
      return super.equals(obj);
    }
    org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure other = (org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure) obj;

    if (!getViolationsList().equals(other.getViolationsList())) return false;
    if (!unknownFields.equals(other.unknownFields)) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (getViolationsCount() > 0) {
      hash = (37 * hash) + VIOLATIONS_FIELD_NUMBER;
      hash = (53 * hash) + getViolationsList().hashCode();
    }
    hash = (29 * hash) + unknownFields.hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure parseFrom(java.nio.ByteBuffer data)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }

  public static org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure parseFrom(
      java.nio.ByteBuffer data, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }

  public static org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure parseFrom(org.apache.ratis.thirdparty.com.google.protobuf.ByteString data)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }

  public static org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure parseFrom(
      org.apache.ratis.thirdparty.com.google.protobuf.ByteString data,
      org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }

  public static org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure parseFrom(byte[] data)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }

  public static org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure parseFrom(
      byte[] data, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }

  public static org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
  }

  public static org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure parseFrom(
      java.io.InputStream input, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(
        PARSER, input, extensionRegistry);
  }

  public static org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(PARSER, input);
  }

  public static org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure parseDelimitedFrom(
      java.io.InputStream input, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(
        PARSER, input, extensionRegistry);
  }

  public static org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure parseFrom(
      org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input) throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
  }

  public static org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure parseFrom(
      org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
      org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(
        PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() {
    return newBuilder();
  }

  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }

  public static Builder newBuilder(org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }

  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   *
   *
   * <pre>
   * Describes what preconditions have failed.
   * For example, if an RPC failed because it required the Terms of Service to be
   * acknowledged, it could list the terms of service violation in the
   * PreconditionFailure message.
   * </pre>
   *
   * Protobuf type {@code google.rpc.PreconditionFailure}
   */
  public static final class Builder extends org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.Builder<Builder>
      implements
      // @@protoc_insertion_point(builder_implements:google.rpc.PreconditionFailure)
      org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailureOrBuilder {
    public static final org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
      return org.apache.ratis.thirdparty.com.google.rpc.ErrorDetailsProto
          .internal_static_google_rpc_PreconditionFailure_descriptor;
    }

    @java.lang.Override
    protected org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.apache.ratis.thirdparty.com.google.rpc.ErrorDetailsProto
          .internal_static_google_rpc_PreconditionFailure_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.class,
              org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Builder.class);
    }

    // Construct using org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.newBuilder()
    private Builder() {
      maybeForceBuilderInitialization();
    }

    private Builder(org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);
      maybeForceBuilderInitialization();
    }

    private void maybeForceBuilderInitialization() {
      if (org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders) {
        getViolationsFieldBuilder();
      }
    }

    @java.lang.Override
    public Builder clear() {
      super.clear();
      if (violationsBuilder_ == null) {
        violations_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000001);
      } else {
        violationsBuilder_.clear();
      }
      return this;
    }

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.Descriptor getDescriptorForType() {
      return org.apache.ratis.thirdparty.com.google.rpc.ErrorDetailsProto
          .internal_static_google_rpc_PreconditionFailure_descriptor;
    }

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure getDefaultInstanceForType() {
      return org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.getDefaultInstance();
    }

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure build() {
      org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure buildPartial() {
      org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure result = new org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure(this);
      int from_bitField0_ = bitField0_;
      if (violationsBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0)) {
          violations_ = java.util.Collections.unmodifiableList(violations_);
          bitField0_ = (bitField0_ & ~0x00000001);
        }
        result.violations_ = violations_;
      } else {
        result.violations_ = violationsBuilder_.build();
      }
      onBuilt();
      return result;
    }

    @java.lang.Override
    public Builder clone() {
      return super.clone();
    }

    @java.lang.Override
    public Builder setField(
        org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
      return super.setField(field, value);
    }

    @java.lang.Override
    public Builder clearField(org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field) {
      return super.clearField(field);
    }

    @java.lang.Override
    public Builder clearOneof(org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.OneofDescriptor oneof) {
      return super.clearOneof(oneof);
    }

    @java.lang.Override
    public Builder setRepeatedField(
        org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field, int index, java.lang.Object value) {
      return super.setRepeatedField(field, index, value);
    }

    @java.lang.Override
    public Builder addRepeatedField(
        org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
      return super.addRepeatedField(field, value);
    }

    @java.lang.Override
    public Builder mergeFrom(org.apache.ratis.thirdparty.com.google.protobuf.Message other) {
      if (other instanceof org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure) {
        return mergeFrom((org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure) other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure other) {
      if (other == org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.getDefaultInstance()) return this;
      if (violationsBuilder_ == null) {
        if (!other.violations_.isEmpty()) {
          if (violations_.isEmpty()) {
            violations_ = other.violations_;
            bitField0_ = (bitField0_ & ~0x00000001);
          } else {
            ensureViolationsIsMutable();
            violations_.addAll(other.violations_);
          }
          onChanged();
        }
      } else {
        if (!other.violations_.isEmpty()) {
          if (violationsBuilder_.isEmpty()) {
            violationsBuilder_.dispose();
            violationsBuilder_ = null;
            violations_ = other.violations_;
            bitField0_ = (bitField0_ & ~0x00000001);
            violationsBuilder_ =
                org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders
                    ? getViolationsFieldBuilder()
                    : null;
          } else {
            violationsBuilder_.addAllMessages(other.violations_);
          }
        }
      }
      this.mergeUnknownFields(other.unknownFields);
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
        org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure parsedMessage = null;
      try {
        parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
      } catch (org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException e) {
        parsedMessage = (org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure) e.getUnfinishedMessage();
        throw e.unwrapIOException();
      } finally {
        if (parsedMessage != null) {
          mergeFrom(parsedMessage);
        }
      }
      return this;
    }

    private int bitField0_;

    private java.util.List<org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation> violations_ =
        java.util.Collections.emptyList();

    private void ensureViolationsIsMutable() {
      if (!((bitField0_ & 0x00000001) != 0)) {
        violations_ =
            new java.util.ArrayList<org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation>(violations_);
        bitField0_ |= 0x00000001;
      }
    }

    private org.apache.ratis.thirdparty.com.google.protobuf.RepeatedFieldBuilderV3<
            org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation,
            org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation.Builder,
            org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.ViolationOrBuilder>
        violationsBuilder_;

    /**
     *
     *
     * <pre>
     * Describes all precondition violations.
     * </pre>
     *
     * <code>repeated .google.rpc.PreconditionFailure.Violation violations = 1;</code>
     */
    public java.util.List<org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation> getViolationsList() {
      if (violationsBuilder_ == null) {
        return java.util.Collections.unmodifiableList(violations_);
      } else {
        return violationsBuilder_.getMessageList();
      }
    }
    /**
     *
     *
     * <pre>
     * Describes all precondition violations.
     * </pre>
     *
     * <code>repeated .google.rpc.PreconditionFailure.Violation violations = 1;</code>
     */
    public int getViolationsCount() {
      if (violationsBuilder_ == null) {
        return violations_.size();
      } else {
        return violationsBuilder_.getCount();
      }
    }
    /**
     *
     *
     * <pre>
     * Describes all precondition violations.
     * </pre>
     *
     * <code>repeated .google.rpc.PreconditionFailure.Violation violations = 1;</code>
     */
    public org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation getViolations(int index) {
      if (violationsBuilder_ == null) {
        return violations_.get(index);
      } else {
        return violationsBuilder_.getMessage(index);
      }
    }
    /**
     *
     *
     * <pre>
     * Describes all precondition violations.
     * </pre>
     *
     * <code>repeated .google.rpc.PreconditionFailure.Violation violations = 1;</code>
     */
    public Builder setViolations(int index, org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation value) {
      if (violationsBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureViolationsIsMutable();
        violations_.set(index, value);
        onChanged();
      } else {
        violationsBuilder_.setMessage(index, value);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * Describes all precondition violations.
     * </pre>
     *
     * <code>repeated .google.rpc.PreconditionFailure.Violation violations = 1;</code>
     */
    public Builder setViolations(
        int index, org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation.Builder builderForValue) {
      if (violationsBuilder_ == null) {
        ensureViolationsIsMutable();
        violations_.set(index, builderForValue.build());
        onChanged();
      } else {
        violationsBuilder_.setMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * Describes all precondition violations.
     * </pre>
     *
     * <code>repeated .google.rpc.PreconditionFailure.Violation violations = 1;</code>
     */
    public Builder addViolations(org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation value) {
      if (violationsBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureViolationsIsMutable();
        violations_.add(value);
        onChanged();
      } else {
        violationsBuilder_.addMessage(value);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * Describes all precondition violations.
     * </pre>
     *
     * <code>repeated .google.rpc.PreconditionFailure.Violation violations = 1;</code>
     */
    public Builder addViolations(int index, org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation value) {
      if (violationsBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureViolationsIsMutable();
        violations_.add(index, value);
        onChanged();
      } else {
        violationsBuilder_.addMessage(index, value);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * Describes all precondition violations.
     * </pre>
     *
     * <code>repeated .google.rpc.PreconditionFailure.Violation violations = 1;</code>
     */
    public Builder addViolations(
        org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation.Builder builderForValue) {
      if (violationsBuilder_ == null) {
        ensureViolationsIsMutable();
        violations_.add(builderForValue.build());
        onChanged();
      } else {
        violationsBuilder_.addMessage(builderForValue.build());
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * Describes all precondition violations.
     * </pre>
     *
     * <code>repeated .google.rpc.PreconditionFailure.Violation violations = 1;</code>
     */
    public Builder addViolations(
        int index, org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation.Builder builderForValue) {
      if (violationsBuilder_ == null) {
        ensureViolationsIsMutable();
        violations_.add(index, builderForValue.build());
        onChanged();
      } else {
        violationsBuilder_.addMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * Describes all precondition violations.
     * </pre>
     *
     * <code>repeated .google.rpc.PreconditionFailure.Violation violations = 1;</code>
     */
    public Builder addAllViolations(
        java.lang.Iterable<? extends org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation> values) {
      if (violationsBuilder_ == null) {
        ensureViolationsIsMutable();
        org.apache.ratis.thirdparty.com.google.protobuf.AbstractMessageLite.Builder.addAll(values, violations_);
        onChanged();
      } else {
        violationsBuilder_.addAllMessages(values);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * Describes all precondition violations.
     * </pre>
     *
     * <code>repeated .google.rpc.PreconditionFailure.Violation violations = 1;</code>
     */
    public Builder clearViolations() {
      if (violationsBuilder_ == null) {
        violations_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000001);
        onChanged();
      } else {
        violationsBuilder_.clear();
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * Describes all precondition violations.
     * </pre>
     *
     * <code>repeated .google.rpc.PreconditionFailure.Violation violations = 1;</code>
     */
    public Builder removeViolations(int index) {
      if (violationsBuilder_ == null) {
        ensureViolationsIsMutable();
        violations_.remove(index);
        onChanged();
      } else {
        violationsBuilder_.remove(index);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * Describes all precondition violations.
     * </pre>
     *
     * <code>repeated .google.rpc.PreconditionFailure.Violation violations = 1;</code>
     */
    public org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation.Builder getViolationsBuilder(int index) {
      return getViolationsFieldBuilder().getBuilder(index);
    }
    /**
     *
     *
     * <pre>
     * Describes all precondition violations.
     * </pre>
     *
     * <code>repeated .google.rpc.PreconditionFailure.Violation violations = 1;</code>
     */
    public org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.ViolationOrBuilder getViolationsOrBuilder(int index) {
      if (violationsBuilder_ == null) {
        return violations_.get(index);
      } else {
        return violationsBuilder_.getMessageOrBuilder(index);
      }
    }
    /**
     *
     *
     * <pre>
     * Describes all precondition violations.
     * </pre>
     *
     * <code>repeated .google.rpc.PreconditionFailure.Violation violations = 1;</code>
     */
    public java.util.List<? extends org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.ViolationOrBuilder>
        getViolationsOrBuilderList() {
      if (violationsBuilder_ != null) {
        return violationsBuilder_.getMessageOrBuilderList();
      } else {
        return java.util.Collections.unmodifiableList(violations_);
      }
    }
    /**
     *
     *
     * <pre>
     * Describes all precondition violations.
     * </pre>
     *
     * <code>repeated .google.rpc.PreconditionFailure.Violation violations = 1;</code>
     */
    public org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation.Builder addViolationsBuilder() {
      return getViolationsFieldBuilder()
          .addBuilder(org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation.getDefaultInstance());
    }
    /**
     *
     *
     * <pre>
     * Describes all precondition violations.
     * </pre>
     *
     * <code>repeated .google.rpc.PreconditionFailure.Violation violations = 1;</code>
     */
    public org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation.Builder addViolationsBuilder(int index) {
      return getViolationsFieldBuilder()
          .addBuilder(index, org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation.getDefaultInstance());
    }
    /**
     *
     *
     * <pre>
     * Describes all precondition violations.
     * </pre>
     *
     * <code>repeated .google.rpc.PreconditionFailure.Violation violations = 1;</code>
     */
    public java.util.List<org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation.Builder>
        getViolationsBuilderList() {
      return getViolationsFieldBuilder().getBuilderList();
    }

    private org.apache.ratis.thirdparty.com.google.protobuf.RepeatedFieldBuilderV3<
            org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation,
            org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation.Builder,
            org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.ViolationOrBuilder>
        getViolationsFieldBuilder() {
      if (violationsBuilder_ == null) {
        violationsBuilder_ =
            new org.apache.ratis.thirdparty.com.google.protobuf.RepeatedFieldBuilderV3<
                org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation,
                org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.Violation.Builder,
                org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure.ViolationOrBuilder>(
                violations_, ((bitField0_ & 0x00000001) != 0), getParentForChildren(), isClean());
        violations_ = null;
      }
      return violationsBuilder_;
    }

    @java.lang.Override
    public final Builder setUnknownFields(final org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }

    // @@protoc_insertion_point(builder_scope:google.rpc.PreconditionFailure)
  }

  // @@protoc_insertion_point(class_scope:google.rpc.PreconditionFailure)
  private static final org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure DEFAULT_INSTANCE;

  static {
    DEFAULT_INSTANCE = new org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure();
  }

  public static org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final org.apache.ratis.thirdparty.com.google.protobuf.Parser<PreconditionFailure> PARSER =
      new org.apache.ratis.thirdparty.com.google.protobuf.AbstractParser<PreconditionFailure>() {
        @java.lang.Override
        public PreconditionFailure parsePartialFrom(
            org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
            org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
          return new PreconditionFailure(input, extensionRegistry);
        }
      };

  public static org.apache.ratis.thirdparty.com.google.protobuf.Parser<PreconditionFailure> parser() {
    return PARSER;
  }

  @java.lang.Override
  public org.apache.ratis.thirdparty.com.google.protobuf.Parser<PreconditionFailure> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public org.apache.ratis.thirdparty.com.google.rpc.PreconditionFailure getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }
}
